@warnings 0
@define INTEGER 4
@define DOUBLE 8
@define TYPETRANSFORM 0
@define TYPECAMERA 1
@script channel

frameOffset; defFile; motDir; applyLoadLimit; loadLimit; f;
duration; objType; diag; /*preb;*/ postb; speed;
firstFrameVal;
apertureHeight;
isAnim_focalLength; isAnim_shutterAngle; isAnim_focalDistance; isAnim_fStop;

oChannelName; channelName; channelTypeOffset;
cameraAttribSize; attribOffset;
autoSense = true;
m2lchannel = 1;
availableChannels = @"Position.X","Position.Y","Position.Z","Rotation.H","Rotation.P","Rotation.B","Scale.X","Scale.Y","Scale.Z","ZoomFactor","BlurLength","FocalDistance","FStop"@;

findChannelTypeOffset
{
	if(objType == TYPECAMERA)
	{
		channelTypeOffset = nil;
		if(channelName.contains("Position.X"))
			channelTypeOffset = DOUBLE * 4;
		if(channelName.contains("Position.Y"))
			channelTypeOffset = DOUBLE * 5;
		if(channelName.contains("Position.Z"))
			channelTypeOffset = DOUBLE * 6;
		if(channelName.contains("Rotation.H"))
			channelTypeOffset = DOUBLE * 7;
		if(channelName.contains("Rotation.P"))
			channelTypeOffset = DOUBLE * 9;
		if(channelName.contains("Rotation.B"))
			channelTypeOffset = DOUBLE * 9;
		if(channelName.contains("Scale.X"))
			channelTypeOffset = DOUBLE * 10;
		if(channelName.contains("Scale.Y"))
			channelTypeOffset = DOUBLE * 11;
		if(channelName.contains("Scale.Z"))
			channelTypeOffset = DOUBLE * 12;	
		
		if(channelName.contains("ZoomFactor"))
			channelTypeOffset = 0;
		if(channelName.contains("BlurLength"))
			channelTypeOffset = DOUBLE * 1;
		if(channelName.contains("FocalDistance"))
			channelTypeOffset = DOUBLE * 2;
		if(channelName.contains("FStop"))
			channelTypeOffset = DOUBLE * 3;
	}
	else if(objType == TYPETRANSFORM)
	{
		channelTypeOffset = nil;
		if(channelName.contains("Position.X"))
			channelTypeOffset = DOUBLE * 0;
		if(channelName.contains("Position.Y"))
			channelTypeOffset = DOUBLE * 1;
		if(channelName.contains("Position.Z"))
			channelTypeOffset = DOUBLE * 2;
		if(channelName.contains("Rotation.H"))
			channelTypeOffset = DOUBLE * 3;
		if(channelName.contains("Rotation.P"))
			channelTypeOffset = DOUBLE * 4;
		if(channelName.contains("Rotation.B"))
			channelTypeOffset = DOUBLE * 5;
		if(channelName.contains("Scale.X"))
			channelTypeOffset = DOUBLE * 6;
		if(channelName.contains("Scale.Y"))
			channelTypeOffset = DOUBLE * 7;
		if(channelName.contains("Scale.Z"))
			channelTypeOffset = DOUBLE * 8;	
		
	}
}
create: channel
{
	
	
	//diag = Diagnostic();
//	diag.showonwrite = true;
	
	oChannelName = channelName = channel.name;
	findChannelTypeOffset();
		
	setdesc("Maya2LW2 General Channel");
	contentDir = getdir("Content");
	appliedBySCGN = integer(globalrecall("M2L_SCGN_APPLY",0));

	defFile = recall("defFile",(string(contentDir,"\\*.m2l")));
	(d1,d2) = split(defFile);
	defFile = string(d1,d2,"*.m2l");
	if(defFile.contains(contentDir) == false)
		defFile = string(contentDir,"\\*.m2l");

	speed = number(recall("speed",1));
	//preb = integer(recall("preb",1));
	postb = integer(recall("postb",3));
	frameOffset = integer(recall("frameOffset",1));

	if(appliedBySCGN == true)
	{
		defFile = globalrecall("M2L_SCGN_FN",defFile);
		speed = number(globalrecall("M2L_SCGN_SPEED",speed));
		//preb = integer(globalrecall("M2L_SCGN_PREB",preb));
		postb = integer(globalrecall("M2L_SCGN_POSTB",postb));
		frameOffset = integer(globalrecall("M2L_SCGN_TGTSTART",frameOffset));
	}
	
}


process: ma, frame, time
{
	if(f)
	{
		if(channelTypeOffset == nil)
			findChannelTypeOffset();
		myFrame = ((time * Scene().fps) * speed) - frameOffset;
		
		if(myFrame <= 0) // pre behavior
		{	
			ma.set(findDataAtFrame(0,channelTypeOffset));
			return;
		}
		
		if(f.offset() <= -1)
			f.reopen("rb");
		myVal = 0;
		
		if(myFrame >= duration - 1) // post behavior
		{
			if(postb == 1 || postb > 3) // first frame
			{
				ma.set(0);				
				return;
			}
			if(postb == 2) // last frame
				myFrame = duration - 1;
			if(postb == 3) // loop
			{
				while(myFrame >= duration)
					myFrame = myFrame - duration;
			}
		}

		lo = floor(myFrame);
		hi = hif = ceil(myFrame); // hif is for referencing data at hiframe, hi is for computing pct
		if(hif == duration)
			hif = 0;

		if(hi == lo)		
			myVal = findDataAtFrame(lo,channelTypeOffset);
		
			
		if(lo != hi)
		{
			pct = (myFrame - lo) / (hi - lo);
			
			loVal = findDataAtFrame(lo,channelTypeOffset);
			hiVal = findDataAtFrame(hif,channelTypeOffset);
			
			myVal = ((hiVal - loVal) * pct) + loVal;
			
			
		}
		
		ma.set(myVal);		
	}
	else
	{
		if(fileexists(defFile))
		{
			f = File(defFile,"rb");
			if(!f)
				error("Opening M2L file for reading.");
			readM2L();
			findChannelTypeOffset();
		}
	}
}
findDataAtFrame: myFrame, typeoffset
{
	if(objType == 0) //transform
		frameSize = 9 * DOUBLE;
	if(objType == 1) //camera
		frameSize = 13 * DOUBLE;
	
	finalOffset = INTEGER * 2; // objType and duration
	if(objType == 1) // camera type
		finalOffset = finalOffset + (DOUBLE * 5) + (INTEGER * 4); // camera related stuff
	
	
	finalOffset = finalOffset + (DOUBLE * duration); // time durations
	
	finalOffset = finalOffset + (myFrame * frameSize); // find frame
	
	finalOffset = finalOffset + (typeoffset);


	f.offset(finalOffset,FROMSTART);
	if(finalOffset > f.linecount())
		return(0);
		
	a = f.readDouble();
	if(a == nil)
		return(0);
	if(channelName.contains("ZoomFactor"))
		a = ((a * 2) / apertureHeight) / 1000;
	if(channelName.contains("BlurLength"))
		a = a / 360;
	if(channelName.contains("Position.X") || channelName.contains("Position.Z") || channelName.contains("Rotation.P"))
		a = -a;
	
	return(a);

}

destroy
{
	if(f)
		f.close();
}
ccbx_sa_active: val
{
	if(val == true)
		return(false);
	else
		return(true);
}
options
{
	info(channelTypeOffset);
	reqbegin("Maya2LW2 General Channels Options");
	
	cfn_fn = ctlfilename("M2L File",defFile,100,1);
	cint_frameOffset = ctlinteger("Frame Offset",frameOffset);
	cpct_speed = ctlpercent("Speed",speed);
	//cpu_preb = ctlpopup("Pre-behavior",preb,@"Dissolve Out","First Frame"@);
	cpu_postb = ctlpopup("Post-behavior",postb,@"Dissolve Out","First Frame","Last Frame","Loop"@);
	ccbx_sa = ctlcheckbox("Auto-Sense Self Channel",autoSense);
	ccpu_chan = ctlpopup("Use M2L Channel",m2lchannel,availableChannels);
	
	ctlactive(ccbx_sa,"ccbx_sa_active",ccpu_chan);
	
	return if(!reqpost());
	
	fn = getvalue(cfn_fn);
	
	frameOffset = getvalue(cint_frameOffset);
	speed = getvalue(cpct_speed);
	//preb = getvalue(cpu_preb);
	postb = getvalue(cpu_postb);
	autoSense = getvalue(ccbx_sa);
	m2lchannel = getvalue(ccpu_chan);
	
	if(autoSense == false)
		channelName = availableChannels[m2lchannel];
	if(autoSense == true)
		channelName = oChannelName;
		

	if(!fileexists(fn))
		warn("File does not exist.");
	else
	{
		defFile = fn;
		(d1,d2) = split(fn);
		store("defFile",string(d1,d2));
		if(f)
			f.close();
		f = File(fn,"rb");
		if(!f)
			error("Error opening M2L file for reading.");
		else
			readM2L();
		findChannelTypeOffset();
		// store first frame values
		
		
	}
	reqend();
	
}

readM2L
{
	sp = split(defFile);
	str = string("M2ML2CC ",sp[3],sp[4]);
	setdesc(str);
	cameraAttribSize = 0;
	attribOffset = 0;

	i = 0;
	f.offset(0);
	objType = f.readInt();
	duration = f.readInt();
	
	if(objType == 1) // if camera m2l
	{
		apertureHeight = f.readDouble();
		apertureHeight = apertureHeight * .0254;
		isAnim_focalLength = f.readInt();
		
			myAttribs[++i] = "ZoomFactor";
		focalLength = f.readDouble();
		isAnim_shutterAngle = f.readInt();
		
			myAttribs[++i] = "BlurLength";
		shutterAngle = f.readDouble();
		isAnim_focalDistance = f.readInt();
		
			myAttribs[++i] = "FocalDistance";
		focalDistance = f.readDouble();
		isAnim_fStop = f.readInt();
		
			myAttribs[++i] = "FStop";
		fStop = f.readDouble();
		
		cameraAttribSize = myAttribs.size();
		for(i=1;i<=myAttribs.size();i++)			
		{
			if(channelName == myAttribs[i])
				attribOffset = i - 1;
		}
	}
	firstFrameVal = findDataAtFrame(0,0);
	
}


load: what, io
{
	if(what == SCENEMODE)
	{
		defFile = io.read();
		frameOffset = integer(io.read());
		speed = number(io.read());
		//preb = integer(io.read());
		postb = integer(io.read());
	}
	
}

save: what, io
{
	if(what == SCENEMODE)
	{
		io.writeln(defFile);
		io.writeln(frameOffset);
		io.writeln(speed);
//		io.writeln(preb);
		io.writeln(postb);

	}
}
