/*==================================================
Maya2LW[2]
Copyright (C) 2005  Lernie D. Ang

This file is part of Maya2LW[2]

Maya2LW[2] is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
==================================================*/

@version 2.6
@warnings 0
@script generic
@define VERSIONNAME "Maya2LW[2] Scene Controller v1.1 Generic"
@define LL_OANAME 1
@define LL_OAGENUS 14
@define INTEGER 4
@define DOUBLE 8
@define _OA 1
@define _FN 2
@define _TYPE 3
@define _DUR 4
@define _DEFCURVE 5
@define _PREB 6
@define _POSTB 7
@define _SRCSTART 8
@define _SRCEND 9
@define _TGTSTART 10
@define _SPEED 11
@define _REMKEYS 12
@define _DURSTART 13
@define _DUREND 14
@define _MDTYPE 15
@define _CAGE 16
@define INTEL 1
@define MOTOROLA 0
//@define _HEIR 13
@define TEMPSCENE "/____MDDAPPLICATORTEMP"
@define MESHOA 1
@define MDDFN 2
@define MDDOPTIONS 3

//@define M2L
cageDir;
tempScene;
C_LISTBOX_W = 320;
C_LISTBOX_H = 300;
LINE_H = 24;
MARGIN = 7;
LISTMARGIN = 30;
applyType;
selListItems; layoutItems; loadList;
contentDir; m2lDir;
c0; c0a; c0b; c1..4; d1..4; e1..4; f1; f4..7; g1; cc2;
c_type; c_dur;
chan_posx; chan_posy; chan_posz; chan_roth; chan_rotp; chan_rotb; chan_sclx; chan_scly; chan_sclz;
chan_focallength; chan_shutterangle; chan_focaldistance; chan_fstop; displayCurrent;
sourceStart = 1;
sourceEnd = 60;
targetStart = 1;
speed = 1.0;
defaultCurve = 3;
preBehavior = 2;
postBehavior = 3;
mdType = 1;
remexistingkeys = false;
donotmodify = false;
tagList;
applyHeir;
filterLayoutSelected;
expose exposedTargetStart, exposedSpeed, exposedPostBehavior, exposedM2LFilename, queryObjectName, updateSignal, querySignal as m2lsc;
mddList;
mddScene; mddSceneDir;
c_mddSceneStr;
c_cageStr;

// automatching
generic
{
	initVariables();
	
	if(filterLayoutSelected == false)
		getLayoutItems();
	if(filterLayoutSelected == true)
		getLayoutItemsCurrentlySelected();
	contentDir = getdir("Content");

	
	reqbegin(VERSIONNAME);
	reqsize(C_LISTBOX_W * 2 + LISTMARGIN + 5, C_LISTBOX_H + LISTMARGIN + 28 + LINE_H*2);

	//c0 = ctlstring("Content Dir",contentDir);
	//c0a = ctlbutton("...",100,"changeDir");
	//c0b = ctlstring("M2L Sub-Dir",m2lSubDir);
	c1 = ctllistbox("Layout Items",C_LISTBOX_W,C_LISTBOX_H,"layoutItems_count","layoutItems_names","layoutItems_event");
	c2 = ctlstring("","");
	c3 = ctlbutton("M2L / MDD",50,"browseM2L");
	//c3 = ctlmenu("Browse",@"Individual","Multiple"@,"browseMenu");
	c_cageButton = ctlbutton("Cage LWO",75,"browseCage");
	c_cageStr = ctlstring("","");
	c_mddSceneButton = ctlbutton("MDD Scene",75,"browseMDDScene");
	c_mddSceneStr = ctlstring("",mddScene);
	
	
	c_type = ctlstring("Type","");
	c_dur = ctlstring("Duration","");
	
	c_type.active(false);
	c_dur.active(false);
	c4 = ctlbutton("Apply / Update All",C_LISTBOX_W / 2,"applyM2L_allobjects");
	c5 = ctlbutton("Apply to Selected",C_LISTBOX_W,"applyM2L_selectedobjects");


	d1 = ctlinteger("Source Start",sourceStart);
	d2 = ctlinteger("Source End",sourceEnd);
	d3 = ctlinteger("Target Start",targetStart);
	d4 = ctlpercent("Speed",speed);

	e1 = ctlpopup("Curve/KeyMove[MD]",defaultCurve,@"Stepped","Linear / KeyMove ON","TCB / KeyMove OFF"@);
	e2 = ctlpopup("PreBehavior",preBehavior,@"Reset","Constant","Repeat","Oscillate","Offset Repeat","Linear"@);
	e3 = ctlpopup("PostBehavior",postBehavior,@"Reset / Dissolve out","Constant / First Frame","Repeat / Last Frame","Oscillate / Composite / Loop","Offset Repeat","Linear"@);

	f1 = ctlcheckbox("Remove Existing Keys",remexistingkeys);
	f6 = ctlbutton("Recall M2L File of Selected",150,"recallM2L_selectedobjects");
	f7 = ctlchoice("MD",mdType,@"_Plug","_MetaPlug"@);


	//f2 = ctlbutton("Automatic Match",150,"autoMatch");
	f2 = ctlcheckbox("Filter to Layout Selected",filterLayoutSelected);
	f3 = ctlbutton("Remove M2L from Object",150,"removeM2LFromObject");
	f4 = ctlcheckbox("Apply as Heirarchial",applyHeir);
	f5 = ctlchoice("  Use",applyType,@"Keyframes","Scripts"@);
	
	sep = ctlsep();

	g1 = ctlstring("Status","[Ready]");
	g1.active(false);
	

	//ctlposition(c0,5,2,C_LISTBOX_W);
	//ctlposition(c0a,C_LISTBOX_W + 8,2,19);
	//ctlposition(c0b,C_LISTBOX_W + LISTMARGIN,2,C_LISTBOX_W);

	ctlposition(c1,5,LINE_H*3);
	//ctlposition(c2,C_LISTBOX_W + LISTMARGIN,LINE_H,C_LISTBOX_W);
	ctlposition(c2,75+2,2,C_LISTBOX_W * 2 - 49);
	ctlposition(c3,5,2,75);
	ctlposition(c_cageButton,5,LINE_H+1,75);
	ctlposition(c_cageStr,75+2,LINE_H+1,C_LISTBOX_W * 2 - 49);
	
	ctlposition(c_mddSceneButton,5,LINE_H*2,75);
	ctlposition(c_mddSceneStr,75+2,LINE_H*2,C_LISTBOX_W * 2 - 49);
	
	ctlposition(c_type,C_LISTBOX_W + LISTMARGIN,LINE_H * 6,C_LISTBOX_W / 2);
	ctlposition(c_dur,8 + C_LISTBOX_W + LISTMARGIN + C_LISTBOX_W / 2,LINE_H * 6,C_LISTBOX_W / 2 - 8);
	
	ctlposition(f4,C_LISTBOX_W + LISTMARGIN + C_LISTBOX_W / 2 - 1,LINE_H * 4,C_LISTBOX_W / 2 + 1);
	ctlposition(f5,C_LISTBOX_W + LISTMARGIN + C_LISTBOX_W / 2 - 1,LINE_H * 5,C_LISTBOX_W / 2 + 1);

	ctlposition(d1,C_LISTBOX_W + LISTMARGIN,LINE_H * 7,C_LISTBOX_W / 2);
	ctlposition(d2,8 + C_LISTBOX_W + LISTMARGIN + C_LISTBOX_W / 2,LINE_H * 7,C_LISTBOX_W / 2 - 8);

	ctlposition(d3,C_LISTBOX_W + LISTMARGIN,LINE_H * 8,C_LISTBOX_W / 2);
	ctlposition(d4,8 + C_LISTBOX_W + LISTMARGIN + C_LISTBOX_W / 2,LINE_H * 8,C_LISTBOX_W / 2 - LISTMARGIN);

	ctlposition(e1,C_LISTBOX_W + LISTMARGIN,LINE_H * 9,C_LISTBOX_W / 2);
	ctlposition(e2,C_LISTBOX_W + LISTMARGIN,LINE_H * 10,C_LISTBOX_W / 2);
	ctlposition(e3,C_LISTBOX_W + LISTMARGIN,LINE_H * 11,C_LISTBOX_W / 2);
	
	ctlposition(c5,C_LISTBOX_W + LISTMARGIN,LINE_H * 4,C_LISTBOX_W / 2);
	ctlposition(c4,C_LISTBOX_W + LISTMARGIN,LINE_H * 5,C_LISTBOX_W / 2);
	
	ctlposition(f1,8 + C_LISTBOX_W + LISTMARGIN + C_LISTBOX_W / 2,LINE_H * 9,C_LISTBOX_W / 2 - LISTMARGIN + 22);
	ctlposition(f6,8 + C_LISTBOX_W + LISTMARGIN + C_LISTBOX_W / 2,LINE_H * 11,C_LISTBOX_W / 2 - LISTMARGIN + 22);
	
	ctlposition(f7,8 + C_LISTBOX_W + LISTMARGIN + C_LISTBOX_W / 2,LINE_H * 10,C_LISTBOX_W / 2 - LISTMARGIN + 22);
	//ctlposition(f1,8 + C_LISTBOX_W + LISTMARGIN + C_LISTBOX_W / 2,LINE_H * 8,C_LISTBOX_W / 2 - 8);
	
	//ctlposition(f3,C_LISTBOX_W + LISTMARGIN + C_LISTBOX_W / 2,LINE_H * 2,C_LISTBOX_W / 2);
	ctlposition(f3,C_LISTBOX_W + LISTMARGIN,LINE_H * 3,C_LISTBOX_W / 2);
	ctlposition(f2,C_LISTBOX_W + LISTMARGIN + C_LISTBOX_W / 2 - 1,LINE_H * 3,C_LISTBOX_W / 2);
	
	ctlposition(sep,11 + C_LISTBOX_W + LISTMARGIN / 2,LINE_H * 13);
	
	ctlposition(g1,15 + C_LISTBOX_W + LISTMARGIN / 2,LINE_H * 14,C_LISTBOX_W);

	
//	ctlrefresh(c0b,"refresh_m2lSubDir");
	//ctlrefresh(c2,"refresh_de");
	
	ctlrefresh(d1,"refresh_de");
	ctlrefresh(d2,"refresh_de");
	ctlrefresh(d3,"refresh_de");
	ctlrefresh(d4,"refresh_de");

	ctlrefresh(e1,"refresh_de");
	ctlrefresh(e2,"refresh_de");
	ctlrefresh(e3,"refresh_de");

	ctlrefresh(f1,"refresh_de");
	ctlrefresh(f4,"refresh_de");
	ctlrefresh(f5,"refresh_de");
	ctlrefresh(f7,"refresh_de");
	ctlrefresh(c2,"refresh_m2lfieldstring");
	ctlrefresh(c_cageStr,"refresh_cagefieldstring");
	ctlrefresh(f2,"refresh_filter");

	reqpost();

	globalstore("M2L_SCGN_APPLY",0);

}
retrieveDirectory: fn
{
	sp = split(fn);
	return(sp[1] + sp[2] + "\\");
}
refresh_filter: val
{
	store("filterLayoutSelected",val);
	if(val == 0)
		getLayoutItems();
	if(val == 1)
		getLayoutItemsCurrentlySelected();
	
	
}
findM2LType: fn
{
	fnf = File(fn,"rb");
	t = fnf.readInt();
	
	fnf.close();
	
	return(t);
	
}
findM2LTopHeader: fn // start and end frames and finds duration
{
	
	fnf = File(fn,"rb");
	if(!fnf)
		return(nil,nil,nil,nil);
	t = fnf.readInt();
	d = fnf.readInt();
	if(t == 1)
		fnf.offset((DOUBLE * 5) + (INTEGER * 6));
	
	srcStart = fnf.readDouble() * Scene().fps;
	if(t == 1)
		fnf.offset((DOUBLE * 5) + (INTEGER * 6) + (DOUBLE * (d - 1)));
	else if(t == 0)
		fnf.offset(DOUBLE * d);
	srcEnd = fnf.readDouble() * Scene().fps;

	fnf.close();
	
	return(t,d,srcStart,srcEnd);
}
initVariables
{
	sp = split(Scene().filename);
	if(sp[1] == nil)
	{
		tempScene = getdir("Scenes") + "\\" +TEMPSCENE;
		mddScene = getdir("Scenes") + "\\" + sp[3] + ".lws";
	}
	else
	{
		tempScene = sp[1]+sp[2]+TEMPSCENE;
		mddScene = sp[1] + sp[2] + sp[3] + "_MDD" + sp[4];
	}
	
	tagList[1] = "M2L2FN";
	tagList[2] = "M2LTYPE";
	tagList[3] = "M2LDUR";
	tagList[4] = "M2LDEFCURVE";
	tagList[5] = "M2LPREB";
	tagList[6] = "M2LPOSTB";
	tagList[7] = "M2LSRCSTART";
	tagList[8] = "M2LSRCEND";
	tagList[9] = "M2LTGTSTART";
	tagList[10] = "M2LSPEED";
	tagList[11] = "M2LREMKEYS";
	tagList[12] = "M2LDURSTART";
	tagList[13] = "M2LDUREND";
	tagList[14] = "M2LMDTYPE";
	tagList[15] = "M2LCAGE";
	//tagList[12] = "M2LHEIR";
	curContentDir = getdir("Content");
	m2lDir = recall("m2lDir",curContentDir);
	updateSignal = false;
	
	if(!m2lDir.contains(curContentDir))
		m2lDir = curContentDir;
	
	selListItems[1] = nil;

	
	applyType = integer(recall("applyType",1));
	applyHeir = integer(recall("applyHeir",0));
	filterLayoutSelected = integer(recall("filterLayoutSelected",0));
}
browseMDDScene
{
	fn = getfile("Export MDD LWS","*.lws",mddSceneDir,false);
	if(fn)
	{
		mddScene = fn;
		setvalue(c_mddSceneStr,mddScene);
		mddSceneDir = retrieveDirectory(fn);
	}
}
browseCage
{
	if(selListItems[1] == nil)
		warn("Select item from list.");
	else
	{
		for(i=1;i<=selListItems.size();i++)
		{
			n = selListItems[i];
			fn = getfile(string("Select LWO Cage for ",layoutItems[n,_OA].name),"*.lwo;*.obj",cageDir,true);
			if(fn)
			{
				if(layoutItems[n,_OA].genus != MESH)
				{
					warn("Invalid assignment of MDD file to non-MESH item.");
					continue;
				}
				layoutItems[n,_CAGE] = fn;
				updateCageStringField();
				cageDir = retrieveDirectory(fn);
			}
			else
				break;

		}			
	}
}
findMDDTopHeader: fn
{
	
	fps = Scene().fps;
	f = File(fn,"r");
	// find first
	d = readInt(f,MOTOROLA);
	v = readInt(f,MOTOROLA);
	ff = readFloat(f,MOTOROLA) * fps;
	f.offset((4*2)+((d - 1)*4),FROM_START);
	lf = readFloat(f,MOTOROLA) * fps;
	f.close();
	return(2,lf - ff + 1,ff,lf);
}
browseM2L
{
	if(selListItems[1] == nil)
		warn("Select item from list.");
	else
	{
		for(i=1;i<=selListItems.size();i++)
		{
			fn = nil;
			n = selListItems[i];
			fn = getfile(string("Select M2L / MDD for ",layoutItems[n,_OA].name),"*.m2l;*.mdd",m2lDir,true);
			if(fn)
			{
				if(endsWith(fn,".mdd"))
				{
					if(layoutItems[n,_OA].genus != MESH)
					{
						warn("Invalid assignment of MDD file to non-MESH item.");
						continue;
					}
					else
						(t,d,srcStart,srcEnd) = findMDDTopHeader(fn);
				}
				else if(endsWith(fn,".m2l"))
					(t,d,srcStart,srcEnd) = findM2LTopHeader(fn);
				
				layoutItems[n,_FN] = fn;
				
				layoutItems[n,_TYPE] = t;
				layoutItems[n,_DUR] = d;
				layoutItems[n,_SRCSTART] = srcStart;
				layoutItems[n,_SRCEND] = srcEnd;
				layoutItems[n,_TGTSTART] = 1;
				layoutItems[n,_SPEED] = 1;
				layoutItems[n,_DURSTART] = srcStart;
				layoutItems[n,_DUREND] = srcEnd;
				layoutItems[n,_MDTYPE] = 1;
				
				(d,p,f,e) = split(fn);
				m2lDir = string(d,p);
				store("m2lDir",m2lDir);
				updateM2LStringField();
				setvalue(d1,srcStart);
				setvalue(d2,srcEnd);
			}
			else
				break;

		}			
	}
}
autoMatch
{
	j = 0;
	selListItems = nil;
	contentDir = getvalue(c0);
	m2lSubDir = getvalue(c0b);
	if(m2lSubDir == " ")
		m2lDir = contentDir + "\\";
	else
		m2lDir = contentDir + m2lSubDir + "\\";
	for(i=1;i<=layoutItems.size();i++)
	{
		a = layoutItems[i,_OA].name;
		f = string(m2lDir,a,".m2l");
		fnf = File(f,"rb");
		if(fnf)
		{
			t = fnf.readInt();
			d = fnf.readInt();

			layoutItems[i,_FN] = f;
			layoutItems[i,_TYPE] = t;
			layoutItems[i,_DUR] = d;
			selListItems[++j] = i;
		}
	}

	donotmodify = true;
	updateM2LStringField();
	setvalue(c1,selListItems);
	setvalue(g1,"Executed AUTOMATIC MATCH.");
}
updateCageStringField
{
	if(selListItems)
	{
		n = selListItems[1];
		setvalue(c_cageStr,layoutItems[n,_CAGE]);
		donotmodify = true;
	}	
}
updateM2LStringField
{
	if(selListItems)
	{
		n = selListItems[1];
		donotmodify = true;
		if(n == nil)
			return;
		if(layoutItems[n,_FN] != nil)
		{
			setvalue(c2,layoutItems[n,_FN]);
			str = string(layoutItems[n,_DURSTART]," - ",layoutItems[n,_DUREND]," \(",layoutItems[n,_DUR],"\)");
			setvalue(c_dur,str);
			if(layoutItems[n,_TYPE] == 0)
				setvalue(c_type,"Transform Only");
			if(layoutItems[n,_TYPE] == 1)
				setvalue(c_type,"Camera-Transform");
			if(layoutItems[n,_TYPE] == 2)
				setvalue(c_type,"MDD");
			if(layoutItems[n,_TYPE] > 2)
				setvalue(c_type,"Unknown");
		}
		else
			setvalue(c2,"");
	}
}
refresh_cagefieldstring: val
{
	if(val == "" || fileexists(val))
	{
		for(i=1;i<=selListItems.size();i++)
		{
			n = selListItems[i];
			if(!n)
				continue;
			layoutItems[n,_CAGE] = val;
		}
	}
	//updateCageStringField();
}

refresh_m2lfieldstring: val
{
	if(donotmodify == true) // to halt setvalue() in list_event from assigning wrong values
	{
		donotmodify = false;
		return;
	}
	
	if(val == "" || fileexists(val))
	{
		fnf = File(val,"rb");
		
		if(fnf)
		{
			if(endsWith(val,".mdd"))
				(t,d,srcStart,srcEnd) = findMDDTopHeader(val);
			else if(endsWith(val,".m2l"))
				(t,d,srcStart,srcEnd) = findM2LTopHeader(val);
		}
		else
		{
			t = nil;
			d = nil;
			srcStart = nil;
			srcEnd = nil;
		}
		
		for(i=1;i<=selListItems.size();i++)
		{
			n = selListItems[i];
			if(!n)
				continue;
			layoutItems[n,_FN] = val;
			layoutItems[n,_TYPE] = t;
			layoutItems[n,_DUR] = d;
			layoutItems[n,_DURSTART] = srcStart;
			layoutItems[n,_DUREND] = srcEnd;
		}
		
	}
	updateM2LStringField();

}
findValidTagNdx: oa, str
{
	i = 0;
	found = false;
	while(true) // find the first empty tag or the tag with Maya2LW2
	{
		i++;
		theTag = oa.getTag(i);
		if(theTag == nil)
		{
			myNdx = i;
			break;
		}
		
		if(theTag.contains(str) == true)
		{
			found = true;
			myNdx = i;
			break;
		}
	}
	return(myNdx,found);
}

applyAsHeirarchial: ndx
{
	if(ndx > layoutItems.size())
		return;

	myName = layoutItems[ndx,_OA].name;
	// get the base name of the m2l file series
	(d,p,f,e) = split(layoutItems[ndx,_FN]);
	
	fileA = string(d,p,strleft(f,f.size() - 2),"_A",e);
	myNameA = layoutItems[ndx,_OA].name + "_A";
	if(!fileexists(fileA))
		warn("M2L _A file does not exist!");

	fileB = string(d,p,strleft(f,f.size() - 2),"_B",e);
	myNameB = layoutItems[ndx,_OA].name + "_B";
	if(!fileexists(fileB))
		warn("M2L _B file does not exist!");

	fileC = string(d,p,strleft(f,f.size() - 2),"_C",e);
	myNameC = layoutItems[ndx,_OA].name + "_C";
	if(!fileexists(fileC))
	{
		fileC = string(d,p,strleft(f,f.size() - 2),"_CShape",e);
		if(!fileexists(fileC))
			warn("M2L _C file does not exist!");
		else
			myNameC = layoutItems[ndx,_OA].name + "_CShape";
	}
		
	for(i=1;i<=3;i++)
	{
		if(i == 1)
		{
			myName = myNameA;
			myFile = fileA;
		}
		if(i == 2)
		{
			myName = myNameB;
			myFile = fileB;
		}
		if(i == 3)
		{
			myFile = fileC;
		}
		f = File(myFile,"rb");
		if(!f)
		{
			str = "Error opening " + myFile;
			warn(str);
			return;
		}
		objType = f.readInt();
		duration = f.readInt();

		if(i != 3)
		{
			AddNull(myName);
			myNullArray[i,_OA] = Scene().firstSelect();
			myNullArray[i,_FN] = myFile;
			myNullArray[i,_TYPE] = layoutItems[ndx,_TYPE];
			myNullArray[i,_DUR] = layoutItems[ndx,_DUR];
			myNullArray[i,_DEFCURVE] = layoutItems[ndx,_DEFCURVE];
			myNullArray[i,_PREB] = layoutItems[ndx,_PREB];
			myNullArray[i,_POSTB] = layoutItems[ndx,_POSTB];
			myNullArray[i,_SRCSTART] = layoutItems[ndx,_SRCSTART];
			myNullArray[i,_SRCEND] = layoutItems[ndx,_SRCEND];
			myNullArray[i,_TGTSTART] = layoutItems[ndx,_TGTSTART];
			myNullArray[i,_SPEED] = layoutItems[ndx,_SPEED];
			myNullArray[i,_REMKEYS] = layoutItems[ndx,_REMKEYS];
			//myNullArray[i,_HEIR] = layoutItems[ndx,_HEIR];
			if(f)
				applyM2L(myNullArray[i],f,duration);
		}
		else
		{
			layoutItems[ndx,_FN] = myFile;
			layoutItems[ndx,_TYPE] = findM2LType(myFile);
			if(f)
				applyM2L(layoutItems[ndx],f,duration);
		}
		
		f.close();
		
	}
	
	pip = Scene().generalopts[3];
	
	if(pip == true)
		ParentInPlace();
	
	SelectItem(myNullArray[2,_OA].id);
	ParentItem(myNullArray[1,_OA].id);
	if(strright(myNameC,5) == "Shape" || strright(myNameC,2) == "_C")
		SelectItem(layoutItems[ndx,_OA].id);
//	else
//		SelectItem(myNullArray[3,_OA].id);
	ParentItem(myNullArray[2,_OA].id);
	SelectItem(layoutItems[ndx,_OA].id);
//	if(strright(myNameC,5) != "Shape")
	//	ParentItem(myNullArray[3,_OA].id);
	
	if(pip == true)
		ParentInPlace();
	
	
}

tagThis: thing
{
	genus = thing[_OA].genus;
	
	for(j=1;j<=tagList.size();j++)
	{
		if(tagList[j].contains("M2L2FN"))
		{
			myPath = parse("\\",thing[_FN]);
			
			for(ti=1;ti<=myPath.size();ti++)
			{
				(i,found) = findValidTagNdx(thing[_OA],"M2L2FN" + ti);
				str = "M2L2FN" + ti + "|" + myPath[ti];
				thing[_OA].setTag(i,str);
			}
		}
		else if(tagList[j].contains("M2LCAGE"))
		{
			if(thing[_CAGE] == "")
				continue;
			myPath = parse("\\",thing[_CAGE]);
			
			for(ti=1;ti<=myPath.size();ti++)
			{
				(i,found) = findValidTagNdx(thing[_OA],"M2LCAGE" + ti);
				
				str = "M2LCAGE" + ti + "|" + myPath[ti];
				thing[_OA].setTag(i,str);
			}
		}
		else
		{
			(i,found) = findValidTagNdx(thing[_OA],tagList[j]);
			str = tagList[j] + "|" + thing[j+1];
			thing[_OA].setTag(i,str);
		}
	}
}
endsWith: str, checkStr
{
	return(strright(str,checkStr.size()) == checkStr);
}
recallM2L_main: ndx
{	
	if(ndx > layoutItems.size())
		return;

	mf = queryM2LFilenameMotionIA(layoutItems[ndx,_OA]);
	if(mf != nil)
	{	
		layoutItems[ndx,_FN] = mf;
		if(mf != "")
			tagThis(layoutItems[ndx]);
	}
}
recallM2L_selectedobjects
{
	ndx = getvalue(c1);
	if(!ndx)
		error("Select an item.");
	for(i=1;i<=ndx.size();i++)
	{
		n = ndx[i];
		recallM2L_main(n);
	}
	setvalue(g1,"Executed RECALL M2L ON SELECTED OBJECTS.");
}
recallM2L_allobjects
{
	for(i=1;i<=layoutItems.size();i++)
	{
		if(layoutItems[i].size() < 2)
			continue;
		if(layoutItems[i,_FN] == nil)
			continue;
		
		recallM2L_main(i);
	}
	setvalue(g1,"Executed RECALL M2L ON ALL OBJECTS.");
}
applyM2L: thing, f, dur
{
	//if(strright(myNameC,2) == "_A")
	tagThis(thing);
	removeExistingMotionIA(thing[_OA]);
	
	if(getvalue(f5) == 2) // script
	{
		store("applyType",getvalue(f5));
		applyUsingMotionIA(thing);
		setvalue(g1,"Executed APPLY USING MOTIONIA.");
		return;
	}

	if(thing[_TYPE] == 1) // if file type camera
	{
		//f.reopen("r");
		f.offset(8,FROMSTART); // make sure it's at the right location
		apertureHeight = f.readDouble();
		isAnim_focalLength = f.readInt();
		focalLength = f.readDouble();
		isAnim_shutterAngle = f.readInt();
		shutterAngle = f.readDouble();
		isAnim_focalDistance = f.readInt();
		focalDistance = f.readDouble();
		isAnim_fStop = f.readInt();
		fStop = f.readDouble();
		
		if(thing[_OA].genus == CAMERA)
		{
			apertureHeight = apertureHeight * .0254;
			str = string("ApertureHeight ",apertureHeight);
			CommandInput(str);
		
			
			fl2 = (focalLength * 2) / apertureHeight;
			str = string("CommandInput ZoomFactor ",fl2 / 1000);
			CommandInput(str); 
			RefreshNow();
			CommandInput("RemoveEnvelope ZoomFactor");
			CommandInput("AddEnvelope ZoomFactor");
			
			sa2 = shutterAngle / 360;
			str = string("CommandInput BlurLength ",sa2);
			CommandInput(str);
			CommandInput("RemoveEnvelope BlurLength");
			CommandInput("AddEnvelope BlurLength");
			
			
			str = string("CommandInput FocalDistance ",focalDistance);
			CommandInput(str);
			CommandInput("RemoveEnvelope FocalDistance");
			CommandInput("AddEnvelope FocalDistance");
			
			
			str = string("CommandInput LensFStop ",fStop);
			CommandInput(str);
			CommandInput("RemoveEnvelope FStop");
			CommandInput("AddEnvelope FStop");
		}
	}
	c = thing[_OA].firstChannel();
	while(c)
	{
		if(thing[_REMKEYS] == true)
			removeExistingKeys(c);

		if(thing[_PREB] == 1)
			c.preBehavior = CHAN_RESET;
		if(thing[_PREB] == 2)
			c.preBehavior = CHAN_CONSTANT;
		if(thing[_PREB] == 3)
			c.preBehavior = CHAN_REPEAT;
		if(thing[_PREB] == 4)
			c.preBehavior = CHAN_OSCILLATE;
		if(thing[_PREB] == 5)
			c.preBehavior = CHAN_OFFSET;
		if(thing[_PREB] == 6)
			c.preBehavior = CHAN_LINEAR;

		if(thing[_POSTB] == 1)
			c.postBehavior = CHAN_RESET;
		if(thing[_POSTB] == 2)
			c.postBehavior = CHAN_CONSTANT;
		if(thing[_POSTB] == 3)
			c.postBehavior = CHAN_REPEAT;
		if(thing[_POSTB] == 4)
			c.postBehavior = CHAN_OSCILLATE;
		if(thing[_POSTB] == 5)
			c.postBehavior = CHAN_OFFSET;
		if(thing[_POSTB] == 6)
			c.postBehavior = CHAN_LINEAR;

		if(c.name.contains("Position.X"))
			chan_posx = c;
		if(c.name.contains("Position.Y"))
			chan_posy = c;
		if(c.name.contains("Position.Z"))
			chan_posz = c;
		if(c.name.contains("Rotation.H"))
			chan_roth = c;
		if(c.name.contains("Rotation.P"))
			chan_rotp = c;
		if(c.name.contains("Rotation.B"))
			chan_rotb = c;
		if(c.name.contains("Scale.X"))
			chan_sclx = c;
		if(c.name.contains("Scale.Y"))
			chan_scly = c;
		if(c.name.contains("Scale.Z"))
			chan_sclz = c;
		if(c.name.contains("ZoomFactor"))
			chan_focallength = c;
		if(c.name.contains("BlurLength"))
			chan_shutterangle = c;
		if(c.name.contains("FocalDistance"))
			chan_focaldistance = c;
		if(c.name.contains("FStop"))
			chan_fstop = c;
			
		c = thing[_OA].nextChannel();
	}	
//	f.offset(64,FROMSTART);
	for(i=1;i<=dur;i++)
		timeindices[i] = f.readDouble(); // get time indices
	
	firstKey = true;

	//diff = number(thing[_TGTSTART]) / Scene().fps;
	//diff = number(diff) - timeindices[1];
	startTime = timeindices[1];
	startTimeDiff = number(thing[_TGTSTART]) / Scene().fps;
	if(thing[_TYPE] == 1)
		camTypeAdd = 4;
	else
		camTypeAdd = 0;
	for(i=1;i<=timeindices.size();i++)
	{
		ti = timeindices[i];
		myFrame = ti * Scene().fps;
		if(myFrame < thing[_SRCSTART])
			continue;
		if(myFrame > thing[_SRCEND])
			continue;
		myTargetTime = (number(thing[_TGTSTART]) - 1) / Scene().fps;
		mySpeed = number(thing[_SPEED]);
		
		ti = (ti - startTime) / mySpeed;
		ti = ti + startTimeDiff;
		
		
		//ti = (timeindices[i] / number(thing[_SPEED])) + (number(thing[_TGTSTART]) / Scene().fps);
		if(f.eof() == true)
		{
			info("Unexpected end of file.");
			return;
		}
		if(thing[_TYPE] == 1) // if file type camera
		{
			
			//if(isAnim_focalLength == 1)
				fl = f.readDouble();	
			//if(isAnim_shutterAngle == 1)
				sa = f.readDouble();
			//if(isAnim_focalDistance == 1)
				fd = f.readDouble();
			//if(isAnim_fStop == 1)
				fs = f.readDouble();
		}
		
		
		px = findDataAtFrame(f,i,0+camTypeAdd,thing[_TYPE]);
		py = findDataAtFrame(f,i,1+camTypeAdd,thing[_TYPE]);
		pz = findDataAtFrame(f,i,2+camTypeAdd,thing[_TYPE]);
		
		
		/*
		valmatrixUp = <0,0,0>;
		valmatrixRight = <0,0,0>;
		valmatrixForward = <0,0,0>;
	*/
		
		rx = findDataAtFrame(f,i,3+camTypeAdd,thing[_TYPE]);
		ry = findDataAtFrame(f,i,4+camTypeAdd,thing[_TYPE]);
		rz = findDataAtFrame(f,i,5+camTypeAdd,thing[_TYPE]);

		
		sx = findDataAtFrame(f,i,6+camTypeAdd,thing[_TYPE]);
		sy = findDataAtFrame(f,i,7+camTypeAdd,thing[_TYPE]);
		sz = findDataAtFrame(f,i,8+camTypeAdd,thing[_TYPE]);
		
		if(thing[_TYPE] == 1) // if file type camera
		{
			if(chan_focallength)
			{
				fl2 = (fl * 2) / apertureHeight;
				a = chan_focallength.createKey(ti,fl2 / 1000);
				if(firstKey)
					chan_focallength.setKeyCurve(a,CHAN_STEPPED);
				
			}			
			
			if(chan_shutterangle)
			{
				sa2 = sa / 360;
				a = chan_shutterangle.createKey(ti,sa2);
				if(firstKey)
					chan_shutterangle.setKeyCurve(a,CHAN_STEPPED);
			}
			
			if(chan_focaldistance)
			{
				a = chan_focaldistance.createKey(ti,fd);
				if(firstKey)
					chan_focaldistance.setKeyCurve(a,CHAN_STEPPED);

			}	
			if(chan_fstop)
			{
				a = chan_fstop.createKey(ti,fs);
				if(firstKey)
					chan_fstop.setKeyCurve(a,CHAN_STEPPED);

			}
		}
				
		if(chan_posx)
		{
			a = chan_posx.createKey(ti,px);
			if(firstKey)
				chan_posx.setKeyCurve(a,CHAN_STEPPED);
		}

		if(chan_posy)
		{
			a = chan_posy.createKey(ti,py);
			if(firstKey)
				chan_posy.setKeyCurve(a,CHAN_STEPPED);
		}


		if(chan_posz)
		{
			a = chan_posz.createKey(ti,-pz);
			if(firstKey)
				chan_posz.setKeyCurve(a,CHAN_STEPPED);
		}

		valvec = <rx,ry,rz>;
		/*
		valvec.x = rx;
		valvec.y = ry;
		valvec.z = rz;
		*/
		

		if(chan_roth)
		{
			a = chan_roth.createKey(ti,-valvec.y);
			if(firstKey)
				chan_roth.setKeyCurve(a,CHAN_STEPPED);
		}
		if(chan_rotp)
		{
			a = chan_rotp.createKey(ti,-valvec.x);
			if(firstKey)
				chan_rotp.setKeyCurve(a,CHAN_STEPPED);
		}
		if(chan_rotb)
		{
			a = chan_rotb.createKey(ti,valvec.z);
			if(firstKey)
				chan_rotb.setKeyCurve(a,CHAN_STEPPED);
		}

		if(chan_sclx)
		{
			a = chan_sclx.createKey(ti,sx);
			if(firstKey)
				chan_sclx.setKeyCurve(a,CHAN_STEPPED);
		}
		
		if(chan_scly)
		{
			a = chan_scly.createKey(ti,sy);
			if(firstKey)
				chan_scly.setKeyCurve(a,CHAN_STEPPED);
		}
		
		if(chan_sclz)
		{
			a = chan_sclz.createKey(ti,sz);
			if(firstKey)
				chan_sclz.setKeyCurve(a,CHAN_STEPPED);
		}
		firstKey = false;
	}	
	
}
applyM2L_allobjects
{
	for(i=1;i<=layoutItems.size();i++)
	{
		if(layoutItems[i].size() < 2)
			continue;
		if(layoutItems[i,_FN] == nil)
			continue;
		
		applyM2L_main(i);
	}
	setvalue(g1,"Executed APPLY M2L ON ALL OBJECTS.");
}
applyM2L_main: ndx
{
	
	if(ndx > layoutItems.size())
		return;
	if(layoutItems[ndx,_FN] == nil)
		return;
	if(endsWith(layoutItems[ndx,_FN],".mdd") == true)
	{
		if(layoutItem[ndx,_OA].genus == MESH) // makes sure it is a mesh
		{
			tagThis(layoutItems[ndx]);
			mddList[mddList.size()+1] = ndx;
		}
	}
	else
	{
		f = File(layoutItems[ndx,_FN],"rb");
		if(!f)
		{
			str = "Error opening " + layoutItems[ndx,_FN];
			warn(str);
			return;
		}
		objType = f.readInt();
		duration = f.readInt();
		
		applyM2L(layoutItems[ndx],f,duration);
		
		f.close();
	}
	applyMDDFiles(layoutItems[ndx,_MDTYPE]);
}
findDataAtFrame: f, myFrame, attrib, objType
{
	if(objType == nil) //if objType was not provided for
	{
		f.offset(0,FROMSTART);
		objType = f.readInt();

	}	
	f.offset(4,FROMSTART);
	duration = f.readInt();
	
	headerSize = INTEGER * 2; // objType and duration
	if(objType 	== 1) // camera type
		headerSize = headerSize + (DOUBLE * 5) + (INTEGER * 4); // camera related stuff

	headerSize = headerSize + (DOUBLE * duration); // time durations
	
	
	if(objType == 1)
	{
		frameOffset = (myFrame - 1) * 104;			
	}
	else
		frameOffset = (myFrame - 1) * 72;
	
	f.offset(headerSize + (attrib*DOUBLE) + frameOffset,FROMSTART);
	a = f.readDouble();
	return(a);

}

stripContentDir: ostr
{
	
	stripStr = getdir("Content");
	if(ostr.contains(stripStr))
	{
		return(strright(ostr,ostr.size() - stripStr.size() - 1));
	}
	else
		return(stripStr);
}
applyMDDFiles: type
{
	if(type == 1) // MD_PLUG
	{
		mdplugstr0 = "Plugin DisplacementHandler 0 MD_Plug";
		mdplugstr1 = "Plugin DisplacementHandler 1 MD_Plug";
	}
	if(type == 2) // MD_METAPLUG
	{
		mdplugstr0 = "Plugin DisplacementHandler 0 MD_MetaPlug";
		mdplugstr1 = "Plugin DisplacementHandler 1 MD_MetaPlug";
	}
	// mdflag keymove matchby actionstart endbehavior replayspeed loadframe
	lineFoundNdx = 0; // counter for LoadObjectLayer and AddNullObjectLayer matches
	m = Mesh();
	while(m)
	{
		meshListID[meshListID.size()+1] = m.id;
		m = m.next();
	}
	if(mddList.size() > 0)
	{
		outScene = mddScene;
		SaveSceneCopy(tempScene);
		outf = File(outScene,"w");
		readf = File(tempScene,"r");
		for(i=1;i<=mddList.size();i++) // goes through every item with mdd in the list
		{
			mdstatus = "none";
			ndx = mddList[i];
			fn = stripContentDir(layoutItems[ndx,_FN]);
			
			oa = layoutItems[ndx,_OA];
			if(type == 2)
				cageobject = stripContentDir(layoutItems[ndx,_CAGE]);
			for(j=1;j<=meshListID.size();j++)
			{
				if(meshListID[j] == oa.id) // found index! j is index
					break;
			}
			
			line = readf.read(); // starts off the reading 
			while(true && readf.eof() == false) // starts reading, will stop when md settings for certain object have been found and modified, or created
			{
				if(line.contains("LoadObjectLayer") || line.contains("AddNullObject"))
				{
					outf.writeln(line); // writes Ladobjectlayer
					lineFoundNdx++;
					if(lineFoundNdx == j) // this is the object that needs to be processed
					{
						while(true && readf.eof() == false) // search for md plug
						{
							line = readf.read();
							if(line.contains(mdplugstr0) || line.contains (mdplugstr1))
							{
								outf.writeln(line);
								str = " filename " + fn;
								outf.writeln(str);
								line = readf.read(); // reads but ignores the filename of the readf
								keymove = integer(layoutItems[ndx,_DEFCURVE]);
								if(keymove == 3)
									keymove = 1;
								else if(keymove == 2 || keymove == 1)
									keymove= 0;
								
								matchby = 1;
								actionstart = integer(layoutItems[ndx,_TGTSTART]) / Scene().fps;
								endbehavior = integer(layoutItems[ndx,_POSTB]) - 1;
								replayspeed = number(layoutItems[ndx,_SPEED]);
								loadframe = 0;
								if(type == 2)
								{
									str = string(" filename ",cageobject);
									outf.writeln(str);
								}
								str = string(" mdflag ",keymove," ",matchby," ",actionstart," ",endbehavior," ",replayspeed," ",loadframe);
								outf.writeln(str);
								line = readf.read(); // reads but ignores the mdflags of the readf
								line = readf.read(); // endplugin
								outf.writeln(line);
								mdstatus = "modified";
								break;
							}
							else if(line.contains("LoadObjectLayer") || line.contains("AddNullObject") || line.contains("ShadowOptions")) // connotes that object haa no mdplug
							{
								lineFoundNdx++;
								outf.writeln(mdplugstr1);
								str = " filename " + fn;
								outf.writeln(str);
								keymove = integer(layoutItems[ndx,_DEFCURVE]);
								if(keymove == 3)
									keymove = 1;
								else if(keymove == 2 || keymove == 1)
									keymove = 0;
								matchby = 1;
								actionstart = integer(layoutItems[ndx,_TGTSTART]) / Scene().fps;
								endbehavior = integer(layoutItems[ndx,_POSTB]) - 1;
								replayspeed = number(layoutItems[ndx,_SPEED]);
								loadframe = 0;
								if(type == 2)
								{
									str = string(" filename ",cageobject);
									outf.writeln(str);
								}
								str = string(" mdflag ",keymove," ",matchby," ",actionstart," ",endbehavior," ",replayspeed," ",loadframe);
								outf.writeln(str);
								outf.writeln("EndPlugin");
								outf.writeln(line); // line is LoadObjectLayer / AddNullObject which denotes that next object is to be processed.
								mdstatus = "created";
								
								break; // breaks from md plug search
							}
							else
								outf.writeln(line);
						}
					}
					else
						mdstatus = "nochange";
				}
				else
				{
					outf.writeln(line);
				}
				line = readf.read();
			}
		}		
		outf.close();
		readf.close();
		filedelete(tempScene);
	}
}
applyM2L_selectedobjects
{
	
	ndx = getvalue(c1);
	if(!ndx)
		error("Select an item.");
	for(i=1;i<=ndx.size();i++)
	{
		n = ndx[i];
		if(applyHeir == true)
			applyAsHeirarchial(n);
		else
			applyM2L_main(n);
	}
	
	setvalue(g1,"Executed APPLY M2L ON SELECTED OBJECTS.");
}
removeM2LFromObject
{
	ndx = getvalue(c1);
	if(!ndx)
		error("Select an item.");
	for(i=1;i<=ndx.size();i++)
	{
		n = ndx[i];
		removeM2L_main(n);
	
		m = layoutItems[n,_OA];
		for(j=1;j<=tagList.size();j++)
		{
			(ii,found) = findValidTagNdx(m,tagList[j]);
			if(found == true)
				m.setTag(ii,"");
		}
	}
	setvalue(g1,"Executed REMOVE M2L FROM OBJECT[S].");
	layoutItems_event(ndx);
}
removeM2L_main: ndx
{
	removeExistingMotionIA(layoutItems[ndx,_OA]);
	layoutItems[ndx,_FN] = "";
	layoutItems[ndx,_TYPE] = nil;
	layoutItems[ndx,_DUR] = nil;
	layoutItems[ndx,_DEFCURVE] = 3;
	layoutItems[ndx,_PREB] = 2;
	layoutItems[ndx,_POSTB] = 2;
	layoutItems[ndx,_SRCSTART] = 1;
	layoutItems[ndx,_SRCEND] = 120;
	layoutItems[ndx,_TGTSTART] = 0;
	layoutItems[ndx,_SPEED] = 1.0;
	layoutItems[ndx,_REMKEYS] = 1;
	layoutItems[ndx,_DURSTART] = 1;
	layoutItems[ndx,_DUREND] = 120;
	layoutItems[ndx,_MDTYPE] = 1;
	layoutItems[ndx,_CAGE] = nil;
	//layoutItems[ndx,_HEIR] = 0;
	

}

refresh_de: val
{
	if(donotmodify == true) // to halt setvalue() in list_event from assigning wrong values
	{
		donotmodify = false;
		return;
	}
	sel = getvalue(c1);	
	fl = getvalue(c2);
	if(fileexists(fl) == false)
		fl = nil;
	a = getvalue(d1);
	b = getvalue(d2);
	c = getvalue(d3);
	d = getvalue(d4);
	e = getvalue(e1);
	f = getvalue(e2);
	g = getvalue(e3);
	h = getvalue(f1);
	i = getvalue(f7);
	applyHeir = getvalue(f4);
	applyType = getvalue(f5);
	store("applyHeir",applyHeir);
	store("applyType",applyType);
	
	for(ii=1;ii<=sel.size();ii++)
	{
		n = sel[ii];
		if(fl != nil)
			layoutItems[n,_FN] = fl;
		layoutItems[n,_SRCSTART] = a;
		layoutItems[n,_SRCEND] = b;
		layoutItems[n,_TGTSTART] = c;
		layoutItems[n,_SPEED] = d;
		layoutItems[n,_DEFCURVE] = e;
		layoutItems[n,_PREB] = f;
		layoutItems[n,_POSTB] = g;
		layoutItems[n,_REMKEYS] = h;
		layoutItems[n,_MDTYPE] = i;
		//layoutItems[n,_HEIR] = i;
	}
}
changeDir
{
	CommandInput("ContentDirectory");
	contentDir = getdir("Content");
	setvalue(c0,contentDir);
}
filterToLayoutSelected
{
	layoutItems = nil;
	getLayoutItemsCurrentlySelected();
	requpdate();
}
applyUsingMotionIA: thing
{
	f = File(thing[_FN],"rb");
	if(!f)
	{
		str = "Error opening " + thing[_FN];
		warn(str);
		return;
	}

	

	objType = f.readInt();
	duration = f.readInt();
	apertureHeight = f.readDouble() * .0254;

	str = string("ApertureHeight ",apertureHeight);
	CommandInput(str);

	//removeExistingMotionIA(thing[_OA]);
	removeExistingKeysFromItem(thing[_OA]);
	globalstore("M2L_SCGN_APPLY",1);
	globalstore("M2L_SCGN_TGTSTART",thing[_TGTSTART]);
	globalstore("M2L_SCGN_SPEED",thing[_SPEED]);
	globalstore("M2L_SCGN_FN",thing[_FN]);
	globalstore("M2L_SCGN_PREB",thing[_PREB]);
	globalstore("M2L_SCGN_POSTB",thing[_POSTB]);
	
	SelectItem(thing[_OA].id);
	CommandInput("ApplyServer ItemMotionHandler Maya2LW2_MotionIA");
	
	if(thing[_TYPE] == 1)
	{
		createEnvelopes(thing[_OA]);
		CommandInput("GE_ApplyServer ChannelHandler Maya2LW2_GeneralChannelsCF");
	}
}
createEnvelopes: oa
{
	SelectItem(oa.id);
	CommandInput("RemoveEnvelope ZoomFactor");
	CommandInput("RemoveEnvelope BlurLength");
	CommandInput("RemoveEnvelope FocalDistance");
	CommandInput("RemoveEnvelope FStop");
	
	CommandInput("AddEnvelope ZoomFactor");
	CommandInput("AddEnvelope BlurLength");
	CommandInput("AddEnvelope FocalDistance");
	CommandInput("AddEnvelope FStop");
	
	CommandInput("GE_OpenWindow 1");
	str = string("GE_SetEnv ",oa.name,".ZoomFactor 0");
	CommandInput(str);
	str = string("GE_SetEnv ",oa.name,".BlurLength 1");
	CommandInput(str);
	str = string("GE_SetEnv ",oa.name,".FocalDistance 1");
	CommandInput(str);
	str = string("GE_SetEnv ",oa.name,".FStop 1");
	CommandInput(str);
	
}

queryM2LFilenameMotionIA: oa
{
	querySignal = true;
	queryObjectName = oa.name;
	RefreshNow();
	myFilename = globalrecall("M2L_queryFilename");

	querySignal = false;
	queryObjectName = nil;
	Refresh();
	return(myFilename);
}

changeAttribsMotionIA: thing
{
	updateSignal = true;
	queryObjectName = thing[_OA].name;
	exposedSpeed = thing[_SPEED];
	exposedTargetStart = thing[_TGTSTART];
	exposedPostBehavior = thing[_POSTB];
	exposedM2LFilename = thing[_FN];
	
	RefreshNow();
	updateSignal = false;
	queryObjectName = nil;
	exposedSpeed = nil;
	exposedTargetStart = nil;
	exposedPostBehavior = nil;
	exposedM2LFilename = nil;
	Refresh();
}

removeExistingMotionIA: oa
{
	sv = oa.server(SERVER_ITEMMOTION_H);
	SelectItem(oa.id);
	for(i=1;i<=sv.size();i++)
	{
		if(sv[i].contains("Maya2LW2_MotionIA"))
		{
			str = string("RemoveServer ItemMotionHandler ",i);
			CommandInput(str);
		}
	}
	
	CommandInput("RemoveEnvelope ZoomFactor");
	CommandInput("RemoveEnvelope BlurLength");
	CommandInput("RemoveEnvelope FocalDistance");
	CommandInput("RemoveEnvelope FStop");
	
}
layoutItems_count
{
	return(layoutItems.size());
}
layoutItems_names: ndx
{
	n = layoutItems[ndx,_OA].name;
	return(n);
}
layoutItems_event: ndx
{
	
	selListItems = nil;
	selListItems = ndx;
	

	n = ndx[1];
	
	fnf = layoutItems[n,_FN];
	
	if(fileexists(fnf) == true)
	{
		if(endsWith(fnf,".mdd"))
			(t,d,srcStart,srcEnd) = findMDDTopHeader(fnf);
		else if(endsWith(fnf,".m2l"))
			(t,d,srcStart,srcEnd) = findM2LTopHeader(fnf);
		
		layoutItems[n,_TYPE] = t;
		layoutItems[n,_DUR] = d;
		layoutItems[n,_DURSTART] = srcStart;
		layoutItems[n,_DUREND] = srcEnd;


	}
	else
	{
		t = nil;
		d = nil;
	}



	if(t == nil)
		displayCurrent[1] = nil;

	if(t > 3)
		displayCurrent[1] = "Unknown Format";

	if(t == 0)
		displayCurrent[1] = "Transform";

	if(t == 1)
		displayCurrent[1] = "Camera";
	if(t == 2)
		displayCurrent[1] = "MDD";
	if(t == 3)
		displayCurrent[1] = "Particle";

	displayCurrent[2] = d;

	donotmodify = true;
	setvalue(d1,layoutItems[n,_SRCSTART]);
	donotmodify = true;
	setvalue(d2,layoutItems[n,_SRCEND]);
	donotmodify = true;
	setvalue(d3,layoutItems[n,_TGTSTART]);
	donotmodify = true;
	setvalue(d4,layoutItems[n,_SPEED]);
	
	donotmodify = true;
	setvalue(e1,layoutItems[n,_DEFCURVE]);
	donotmodify = true;
	setvalue(e2,layoutItems[n,_PREB]);
	donotmodify = true;
	setvalue(e3,layoutItems[n,_POSTB]);
	donotmodify = true;
	setvalue(f1,layoutItems[n,_REMKEYS]);
	donotmodify = true;
	if(layoutItems[n,_CAGE] != "")
	{
		
		setvalue(c_cageStr,layoutItems[n,_CAGE]);
	}
	
	donotmodify = true;
	setvalue(f7,layoutItems[n,_MDTYPE]);
	donotmodify = true;
	
	
	updateM2LStringField();


}
removeExistingKeys: c
{
	kc = c.keyCount;
	for(ii=1;ii<=kc;ii++)
		c.deleteKey(c.keys[1]);
}
removeExistingKeysFromItem: oa
{
	chan = oa.firstChannel();
	while(chan)
	{
		removeExistingKeys(chan);
		chan = oa.nextChannel();
	}
}
getLayoutItems
{
	layoutItems = nil;
	i = 0;

	while(true)
	{
		for(k=1;k<=3;k++)
		{
			if(k == 1)
				m = Mesh();
			if(k == 2)
				m = Light();
			if(k == 3)
				m = Camera();
			while(m)
			{
				layoutItems[++i,_OA] = m;
				for(j=1;j<=tagList.size();j++)
				{
					if(tagList[j].contains("M2L2FN")) // collect filename separation
					{
						ti = 0;
						myStr = "";
						while(true)
						{
							++ti;
							(ndx,found) = findValidTagNdx(m,string("M2L2FN" + ti));
							//info("M2L2FN" + ti);
							if(found)
							{
								tagStr = parse("|",m.getTag(ndx));
								if(ti == 1)
									myStr = myStr + tagStr[2];
								else
									myStr = myStr + "\\" + tagStr[2];
							}
							else
								break;
						}
						layoutItems[i,_FN] = myStr;
						
					}
					else if(tagList[j].contains("M2LCAGE")) // collect filename separation
					{
						ti = 0;
						myStr = "";
						while(true)
						{
							++ti;
							(ndx,found) = findValidTagNdx(m,string("M2LCAGE" + ti));
							//info("M2L2FN" + ti);
							if(found)
							{
								tagStr = parse("|",m.getTag(ndx));
								if(ti == 1)
									myStr = myStr + tagStr[2];
								else
									myStr = myStr + "\\" + tagStr[2];
							}
							else
							{
								myStr = "";
								break;
							}
						}
						layoutItems[i,_CAGE] = myStr;
						
					}
					else
					{
						(ndx,found) = findValidTagNdx(m,tagList[j]);	
						if(found)			
						{
							myTag = parse("|",m.getTag(ndx));
							if(myTag.size() > 1)
								layoutItems[i,j+1] = myTag[2];
						}
						else
							layoutItems[i,j+1] = setLayoutItemAtDefaultValue(j+1);
					}
				}				
				if(fileexists(layoutItems[i,_FN]))
				{
					if(endsWith(layoutItems[i,_FN],".mdd"))
						(t,d,srcStart,srcEnd) = findMDDTopHeader(layoutItems[i,_FN]);
					else if(endsWith(layoutItems[i,_FN],".m2l"))
						(t,d,srcStart,srcEnd) = findM2LTopHeader(layoutItems[i,_FN]);	
					layoutItems[i,_DURSTART] = srcStart;
					layoutItems[i,_DUREND] = srcEnd;
				}
				else
				{
					layoutItems[i,_DURSTART] = srcStart;
					layoutItems[i,_DUREND] = srcEnd;
				}
				m = m.next();
			}
		}
		break;
	}
	if(reqisopen())
		requpdate();
}

getLayoutItemsCurrentlySelected
{
	layoutItems = nil;
	m = Scene().getSelect();
	for(i=1;i<=m.size();i++)
	{
		layoutItems[i,_OA] = m[i];
		for(j=1;j<=tagList.size();j++)
		{
			if(tagList[j].contains("M2L2FN")) // collect filename separation
			{
				ti = 0;
				myStr = "";
				while(true)
				{
					++ti;
					(ndx,found) = findValidTagNdx(m[i],string("M2L2FN" + ti));
					//info("M2L2FN" + ti);
					if(found)
					{
						tagStr = parse("|",m[i].getTag(ndx));
						if(ti == 1)
							myStr = myStr + tagStr[2];
						else
							myStr = myStr + "\\" + tagStr[2];
					}
					else
						break;
				}
				layoutItems[i,_FN] = myStr;
				
			}
			else
			{
				(ndx,found) = findValidTagNdx(m[i],tagList[j]);	
				
				if(found)			
				{
					myTag = parse("|",m[i].getTag(ndx));
					if(myTag.size() > 1)
						layoutItems[i,j+1] = myTag[2];
				}
				else
					layoutItems[i,j+1] = setLayoutItemAtDefaultValue(j+1);
			}
		}
		if(fileexists(layoutItems[i,_FN]))
		{
			(t,d,srcStart,srcEnd) = findM2LTopHeader(layoutItems[i,_FN]);
			layoutItems[i,_DURSTART] = srcStart;
			layoutItems[i,_DUREND] = srcEnd;
		}
		else
		{
			layoutItems[i,_DURSTART] = srcStart;
			layoutItems[i,_DUREND] = srcEnd;
		}
	}
	if(reqisopen())
		requpdate();
}

setLayoutItemAtDefaultValue: myNdx
{
	if(myNdx == _FN)
		return("");
	
	if(myNdx == _SPEED || myNdx == _REMKEYS || myNdx == _SRCSTART || myNdx == _MDTYPE)
		return(1);
	if(myNdx == _DEFCURVE)
		return(3);
	if(myNdx == _PREB)
		return(2);
	if(myNdx == _POSTB)
		return(3);
	if(myNdx == _TGTSTART)
		return(1);
	
	if(myNdx == _SRCEND)
		return(120);
	
	return(nil);
	
/* 	_OA
	_FN
	_TYPE
	_DUR
	_DEFCURVE
	_PREB
	_POSTB
	_SRCSTART
	_SRCEND
	_TGTSTART
	_SPEED
	_REMKEYS
	_HEIR */

}
/*======================================================================================================
the code below by Stuart Aitken, Axis Animation
======================================================================================================*/
matrix_mult: A, B
{
    C[1] = <(A[1].x*B[1].x)+(A[1].y*B[2].x)+(A[1].z*B[3].x),(A[1].x*B[1].y)+(A[1].y*B[2].y)+(A[1].z*B[3].y),(A[1].x*B[1].z)+(A[1].y*B[2].z)+(A[1].z*B[3].z)>;

    C[2] = <(A[2].x*B[1].x)+(A[2].y*B[2].x)+(A[2].z*B[3].x),(A[2].x*B[1].y)+(A[2].y*B[2].y)+(A[2].z*B[3].y),(A[2].x*B[1].z)+(A[2].y*B[2].z)+(A[2].z*B[3].z)>;

    C[3] = <(A[3].x*B[1].x)+(A[3].y*B[2].x)+(A[3].z*B[3].x),(A[3].x*B[1].y)+(A[3].y*B[2].y)+(A[3].z*B[3].y),(A[3].x*B[1].z)+(A[3].y*B[2].z)+(A[3].z*B[3].z)>;

    return C;
}
vec_HPB: mat
{
	//normalises vector then uses trig to solve H,P,B
	l = normalize(mat[1]);
	m = normalize(mat[2]);
	n = normalize(mat[3]);
	rotP = asin(-n.y);

	x = n.z/cos(rotP);
	x = max(-1.0,x);
	x = min(1.0,x);
	rotH = acos(x);
	rotH = (2*PI - rotH) if (n.x<0.0);

	x = m.y/cos(rotP);
	x = max(-1.0,x);
	x = min(1.0,x);
	rotB = acos(x);
	rotB = (2*PI - rotB) if (l.y<0.0);
	rot = <deg(rotH),deg(rotP),deg(rotB)>;
	rot.x = rot.x - 360 if rot.x > 180;
	return(rot);
}
readInt : inFile, pcOrder
{
   var byte[ 4 ];
   
   readBytes( inFile, byte, 4, pcOrder );

   if ( byte[ 1 ] < 128 )      
      return byte[ 1 ] * 16777216
           + byte[ 2 ] * 65536
           + byte[ 3 ] * 256
           + byte[ 4 ];
   else
      return -(( 255 - byte[ 1 ] ) * 16777216
             + ( 255 - byte[ 2 ] ) * 65536
             + ( 255 - byte[ 3 ] ) * 256
             + ( 256 - byte[ 4 ] ));
}
readBytes : inFile, byte, n, pcOrder
{
   if ( pcOrder ) {
      first = n;
      stop  = 0;
      step  = -1;
   }
   else {
      first = 1;
      stop  = n + 1;
      step  = 1;
   }
   
   for ( i = first; i != stop; i += step )
      byte[ i ] = inFile.readByte();
}
readFloat : inFile, pcOrder
{
   var byte[ 4 ];
   
   readBytes( inFile, byte, 4, pcOrder );

   if ( byte[ 1 ] == 0 && byte[ 2 ] == 0 && byte[ 3 ] == 0 && byte[ 4 ] == 0 )
    return 0;

   m = 1.0 + (( byte[ 2 ] % 128 ) * 65536 + byte[ 3 ] * 256 + byte[ 4 ] )
     / 8388608.0;
   e = ( byte[ 1 ] % 128 ) * 2 + integer( byte[ 2 ] / 128 ) - 127;
   x = m * pow( 2.0, e );
   if ( byte[ 1 ] > 127 ) x = -x;

   return x;
}