@warnings 0
contentDir;
m2lSubDir;
m2lDir;
theList;
c1..3;

generic // invert byte order
{
	contentDir = getdir("Content");
	m2lDir = recall("m2lDir",contentDir);
	
	reqbegin("Maya2LW[2] M2MD to MDD Converter");
	
	c0 = ctlbutton("Change Directory",800,"changeDir");
	c1 = ctlstring("Current Directory",m2lDir,800);
	c3 = ctllistbox("M2MD Files",800,600,"list_count","list_names");

	populateList();

	ctlrefresh(c1,"refresh_c");
	return if(!reqpost());

	sel = getvalue(c3);
	if(!sel)
		return;
		
	for(i=1;i<=sel.size();i++)
	{
		ndx = sel[i];

		if(m2lSubDir == " " || m2lSubDir == "")
			fn = contentDir + "\\" + theList[ndx];
		else
			fn = contentDir + "\\" + m2lSubDir + "\\" + theList[ndx];

		fp = split(fn);	

		fnout = fp[1] + fp[2] + fp[3] + ".mdd";

	
		reqend();
	
		f = File(fn,"rb");
		if(f)
		{
			fout = File(fnout,"wb");

			a = f.readInt();
			fout.writeInt(a,true);
			a = f.readInt();
			fout.writeInt(a,true);

			while(!f.eof())
			{
				a = f.readDouble();
				if(a != nil)
					writeFloat(fout,a,false);
		
			}
	
			f.close();
			fout.close();
		}
		else
			error("Error opening file.");
	}
	info("M2MD to MDD conversion done.");
}
populateList
{
	theList = nil;
	theList = matchfiles(m2lDir,"*.m2md");
}
changeDir
{
	fn = getfile("Select directory to search for M2MD files","[DIR]","*.m2md",1);
	if(!fn)
		return;
	fns = split(fn);
	m2lDir = fns[1] + fns[2];
	store("m2lDir",m2lDir);
	setvalue(c1,m2lDir);
	populateList();
	requpdate();
	
}
refresh_c: val
{
	m2lDir = val;
	store("m2lDir",m2lDir);
	populateList();
	requpdate();
}
list_count
{

	return(theList.size());
}
list_names: ndx
{
	return(theList[ndx]);
	
}


writeInt : outFile, i, pcOrder
{
   var byte[ 4 ];

   if ( i >= 0 ) {
      byte[ 1 ] = integer( i / 16777216 );
      byte[ 2 ] = integer( i / 65536 ) % 256;
      byte[ 3 ] = integer( i / 256 ) % 256;
      byte[ 4 ] = i % 256;
   }
   else {
      j = -i - 1;
      byte[ 1 ] = 255 - integer( j / 16777216 );
      byte[ 2 ] = 255 - ( integer( j / 65536 ) % 256 );
      byte[ 3 ] = 255 - ( integer( j / 256 ) % 256 );
      byte[ 4 ] = 255 - ( j % 256 );
   }

   writeBytes( outFile, byte, 4, pcOrder );
}
writeBytes : outFile, byte, n, pcOrder
{
   if ( pcOrder ) {
      first = n;
      stop  = 0;
      step  = -1;
   }
   else {
      first = 1;
      stop  = n + 1;
      step  = 1;
   }

   for ( i = first; i != stop; i += step )
      outFile.writeByte( byte[ i ] );
}

writeFloat : outFile, x, pcOrder
{
   var byte[ 4 ];

   if(x==0)
   {
      byte[ 4 ]=byte[ 3 ]=byte[ 2 ]=byte[ 1 ]=0;
   }
   else
   {
	   lgx = log( abs( x )) / log( 2.0 );
	   e = integer( floor( lgx ));
	   m = integer( floor(( pow( 2.0, lgx - e ) - 1.0 ) * 8388608 ));
	   e += 127;

	   byte[ 1 ] = integer( e / 2 ) + ( x < 0 ? 128 : 0 );
	   byte[ 2 ] = integer( m / 65536 ) + 128 * ( e % 2 );
	   byte[ 3 ] = integer( m / 256 ) % 256;
	   byte[ 4 ] = m % 256;
   }

   writeBytes( outFile, byte, 4, pcOrder );

}
readInt : inFile, pcOrder
{
   var byte[ 4 ];

   readBytes( inFile, byte, 4, pcOrder );

   if ( byte[ 1 ] < 128 )
      return byte[ 1 ] * 16777216
           + byte[ 2 ] * 65536
           + byte[ 3 ] * 256
           + byte[ 4 ];
   else
      return -(( 255 - byte[ 1 ] ) * 16777216
             + ( 255 - byte[ 2 ] ) * 65536
             + ( 255 - byte[ 3 ] ) * 256
             + ( 256 - byte[ 4 ] ));
}

readBytes : inFile, byte, n, pcOrder
{
   if ( pcOrder ) {
      first = n;
      stop  = 0;
      step  = -1;
   }
   else {
      first = 1;
      stop  = n + 1;
      step  = 1;
   }

   for ( i = first; i != stop; i += step )
      byte[ i ] = inFile.readByte();
}
