@warnings 0
c0;
defFile; hts;
//startFrame; endFrame; duration;

validateObjectName: myName
{
	temp = searchAndReplace(myName,"\:","_");
	if(temp == "")
		return(myName);
	else
		return(temp);
	//myName = searchAndReplace(myName,"\\","_");
	//myName = searchAndReplace(myName,"/","_");
	
	
	/*
	myName = searchAndReplace(myName,"?","_");
	myName = searchAndReplace(myName,"<","_");
	myName = searchAndReplace(myName,">","_");
	myName = searchAndReplace(myName,"*","_");
	
	myName = searchAndReplace(myName,"\"","_");
*/
	
}
searchAndReplace: oName, search, replace
{
	exp = regexp(search,replace);
	oName ~= exp;
	return(oName);
}
writeHeader: fn, myGenus, sf, ef, duration, obj
{
	if(myGenus == CAMERA)
	{
		type = 1;
		apertureHeight = 2 * obj.focalLength(0) / obj.zoomFactor(0) * .03937;
		fn.writeInt(type);
		fn.writeInt(duration);
		fn.writeDouble(apertureHeight);
		fn.writeInt(1);
		fn.writeDouble(obj.focalLength(0));
		bl = obj.blurLength(0);
		bl = bl * 360;
		fn.writeInt(1);
		fn.writeDouble(bl);
		fn.writeInt(1);
		fn.writeDouble(obj.focalDistance(0));
		fn.writeInt(1);
		fn.writeDouble(obj.fStop(0));
	}
	else
	{
		type = 0;
		fn.writeInt(type);
		fn.writeInt(duration);
	}
	
	for(i=sf;i<=ef;i++)
		fn.writeDouble(i / Scene().fps);
	
}
c_active: val
{
	return(false);
}

validateFilename: val
{
	(d,p,f,e) = split(val);
	if(e != ".m2l")
		setvalue(c1,string(d,p,f,".m2l"));
}
changeDir
{
	temp = getfile("Change Directory","[DIR]",defFile,1);
	if(temp)
	{
		pt = split(temp);
		defFile = pt[1] + pt[2];
		setvalue(c0,defFile);
	}
	store("defFile",defFile);
}
generic
{
	hts = recall("hts",".");
	contentDir = getdir("Content");
	
	defFile = recall("defFile",contentDir);

	saveBones = integer(recall("saveBones",0));
	
	if(defFile.contains(contentDir) == false)
		defFile = contentDir + "\\*.m2L";
	
	
	reqbegin("Export LightWave Motion to M2L v1.2");

	c0 = ctlstring("Current Directory",defFile,400);
	c1 = ctlbutton("Change Directory",400,"changeDir");
	c2 = ctlcheckbox("Save Bones of Object",saveBones);
	c3 = ctlstring("Heirarchy Token String",hts);
	//c1 = ctlfilename("Save to M2L File",defFile,100,1);
	//ctlrefresh(c1,"validateFilename");
	return if(!reqpost());
		
	defFile = getvalue(c0);
	saveBones = getvalue(c2);
	hts = getvalue(c3);
	if(hts == nil)
		hts = ".";
	store("defFile",defFile);
	store("saveBones",saveBones);
	store("hts",hts);
	
	reqend();
	
	s = Scene().getSelect();
	
	//(d,p,f,e) = split(defFile);
	
	for(i=1;i<=s.size();i++)
	{
		obj = s[i];
		exportM2L(obj,nil);
		if(saveBones == true)
		{
			myBone = obj.bone();
			while(myBone)
			{
				exportM2L(obj,myBone);
				myBone = myBone.next();
			}
		}
	}
}

exportM2L: obj, myBone
{
	startFrame = Scene().previewstart;
	endFrame = Scene().previewend;
	duration = endFrame - startFrame + 1;
	sm = 0;
	myGenus = obj.genus;
	
	objName = validateObjectName(obj.name);
	
	if(myBone == nil)
		fnStr = string(defFile,"\\",objName,".m2l");
	else
	{
		myBoneName = validateObjectName(myBone.name);
		fnStr = string(defFile,"\\",objName,hts,myBoneName,".m2l");
	}
	//info(objName);
	
	fn = File(fnStr,"wb");
	if(!fn)
	{
		str = string("Unable to generate ",fnStr," for writing.");
		warn(str);
	}
	
	
	
	if(myGenus == BONE)
		myGenus  = 0;
	writeHeader(fn,myGenus,startFrame,endFrame,duration,obj);
	for(j=startFrame;j<=endFrame;j++)
	{
		pos = obj.getPosition(j / Scene().fps);
		rot = obj.getRotation(j / Scene().fps);
		scl = obj.getScaling(j / Scene().fps);
	
		if(myGenus == CAMERA)
		{
			fn.writeDouble(obj.focalLength(j / Scene().fps));
			bl = obj.blurLength(j / Scene().fps);
			bl = bl * 360;
			fn.writeDouble(bl);
			fn.writeDouble(obj.focalDistance(j / Scene().fps));
			fn.writeDouble(obj.fStop(j / Scene().fps));
			
		}
		
		fn.writeDouble(pos.x);
		fn.writeDouble(pos.y);
		fn.writeDouble(-pos.z);

		fn.writeDouble(-rot.p);
		fn.writeDouble(-rot.h);
		fn.writeDouble(rot.b);
		
		fn.writeDouble(scl.x);
		fn.writeDouble(scl.y);
		fn.writeDouble(scl.z);
		
	}
	++sm;
	fn.close();
	
		
}