@warnings 0

@define INTEL 1
@define MOTOROLA 0
@define LINE 24
@define RIGHTMARGIN 50
defDir;
mddList;
showFullPath;
c0..8;
d0..6;
f0..1;



f1_refresh: val
{
	if(strright(val,4) != ".mdd")
	{
		setvalue(f1,val + ".mdd");
		store("outputMDDFilename",val + ".mdd");
	}
		
}

resize: w, h
{
	ctlposition(c0,5,5);
	ctlposition(c1,5,LINE*2,w - RIGHTMARGIN,h - LINE*11 - 5);

	ctlposition(f1,5,h - LINE*8,w - RIGHTMARGIN);
	
	ctlposition(c2,5,h - LINE*9,150);
	ctlposition(c3,170,h - LINE*9,150);
	
	ctlposition(c7,5,h - LINE*7,150);
	ctlposition(c8,170,h - LINE*7,150);
	ctlposition(c4,340,h - LINE*7,150);
	ctlposition(c5,170,h - LINE*6,150);
	ctlposition(c6,340,h - LINE*6,150);
	ctlposition(d0,5,h - LINE*6,150);
	ctlposition(d1,5,h - LINE*5,150);
	ctlposition(d2,170,h - LINE*5,150);
	ctlposition(d3,5,h - LINE*4,150);
	ctlposition(d4,5,h - LINE*3,150);
	
	ctlposition(d5,170,h - LINE*4,150);
	ctlposition(d6,170,h - LINE*3,150);
	
	
}
moveUp
{
	j = 0;
	listSel = getvalue(c1);
	for(i=1;i<=listSel.size();i++)
	{
		ndx = listSel[i];
		myItem = mddList[ndx];
		// get above
		if(ndx == 1)
		{
			newSel[++j] = ndx;
			continue;
		}
		else
			topItem = mddList[ndx - 1];
		
		mddList[ndx - 1] = myItem;
		
		mddList[ndx] = topItem;
		requpdate();
		
		newSel[++j] = ndx - 1;
	}
	setvalue(c1,newSel);
	
}
moveDn
{
	j = 0;
	listSel = getvalue(c1);
	for(i=listSel.size();i>=1;i--)
	{
		ndx = listSel[i];
		myItem = mddList[ndx];
		// get above
		if(ndx == mddList.size())
		{
			newSel[++j] = ndx;
			continue;
		}
		else
			dnItem = mddList[ndx + 1];
		
		mddList[ndx + 1] = myItem;
		mddList[ndx] = dnItem;
		
		requpdate();
		
		newSel[++j] = ndx + 1;
	}
	setvalue(c1,newSel);
	
}
generic // export selected items to lws
{
	//if(fileexists("mdd_stitch.exe") == false)
		//error("Unable to locate MDD_Stitch.exe in PATH environment. Can not continue.");
	mddList[1] = nil;
	fps = number(recall("fps",30));
	duration = 0;
	vertices = 0;
	startTime = endTime = startFrame = endFrame = 0;
	timeOffset = number(recall("timeOffset",0));
	frameOffset = integer(recall("frameOffset",0));
	
	showFullPath = false;
	defDir = recall("defDir",getdir("Objects"));
	outputMDDFilename = recall("outputMDDFilename",getdir("Objects"));
	
	reqbegin("Stitch MDD Files");
	reqresize("resize",535,350,1600,1200);
	c0 = ctltext("REMINDERS:","MDD stitching will proceed from top to bottom","Output MDD file will be placed in same directory as listed MDD files.");
	c1 = ctllistbox("MDD Files",600,250,"list_count","list_names","list_event");
	f1 = ctlstring("Output MDD",outputMDDFilename);
	
	c2 = ctlbutton("Add MDD File",150,"addMDDFileButton");
	c3 = ctlbutton("Remove MDD File",150,"remMDDFileButton");
	c4 = ctlcheckbox("Show Full File Path",showFullPath);
	c5 = ctlnumber("Time Offset",timeOffset);
	c6 = ctlinteger("Frame Offset",frameOffset);
	c7 = ctlbutton("MOVE UP",150,"moveUp");
	c8 = ctlbutton("MOVE DOWN",150,"moveDn");
	
	
	d0 = ctlnumber("FPS Interpret",fps);
	d1 = ctlinteger("Duration",duration);
	d2 = ctlinteger("Vertices",vertices);
	d3 = ctlnumber("Start Time",startTime);
	d4 = ctlnumber("End Time",endTime);
	d5 = ctlnumber("Start Frame",startFrame);
	d6 = ctlnumber("End Frame",endFrame);
	
	ctlrefresh(f1,"f1_refresh");
	ctlrefresh(d0,"d0_refresh");
	ctlrefresh(c4,"c4_refresh");
	ctlrefresh(c5,"c5_refresh");
	ctlrefresh(c6,"c6_refresh");

	d1.active(false);
	d2.active(false);
	d3.active(false);
	d4.active(false);
	d5.active(false);
	d6.active(false);

	return if(!reqpost());

	store("timeOffset",timeOffset = getvalue(c5));
	
	outputMDDFilename = getvalue(f1);
	
	if(strright(outputMDDFilename,4) != ".mdd")
		outputMDDFilename = outputMDDFilename + ".mdd";
	
	store("outputMDDFilename",outputMDDFilename);
	// start processing
	
	sp = split(mddList[1]);
	d = sp[1] + sp[2];
	tempFile = "mddStitchTempFile";
	chdir(d); // all MDD files must reside in the same directory
	
	for(i=1;i<=mddList.size();i++)
	{
		info(i);
		if(i == 1)
		{
			
			sp1 = split(mddList[i]);
			sp2 = split(mddList[i+1]);
			str = string("mdd_stitch.exe \"",sp1[3]+sp1[4],"\" \"",sp2[3]+sp2[4],"\" \"",tempFile,"\" ",timeOffset);
			spawn(str);
			i++;
		}
		else
		{
			tempFile2 = tempFile + "2";
			sp = split(mddList[i]);
			str = string("mdd_stitch.exe \"",tempFile,"\" \"",sp[3]+sp[4],"\" \"",tempFile2,"\" ",timeOffset);
			spawn(str);
			filedelete(tempFile);
			filerename(tempFile2,tempFile);
			
		}
	}
	filerename(tempFile,outputMDDFilename);	
	
	reqend();
}
c5_refresh: val
{
	if(donotmodify == true)
		return;
	donotmodify = true;
	fps = getvalue(d0);
	setvalue(c6,val * fps);
	donotmodify = false;
}
c6_refresh: val
{
	if(donotmodify == true)
		return;
	
	donotmodify = true;
	fps = getvalue(d0);
	setvalue(c5,val / fps);
	donotmodify = false;
}
d0_refresh: val
{
	listSel = getvalue(c1);
	if(listSel)
	{
		ndx = listSel[1];
		updateValues(File(mddList[ndx],"r"));
	}
}
c4_refresh: val
{
	showFullPath = val;
	requpdate();
}

remMDDFileButton
{
	listSel = getvalue(c1);
	for(i=1;i<=listSel.size();i++)
	{
		ndx = listSel[i];
		mddList[ndx] = nil;
	}
	mddList.pack(); mddList.trunc();
	requpdate();
}

addMDDFileButton
{
	fn = getfile("Add MDD File","*.mdd",defDir,1);
	if(fileexists(fn) == true)
	{
		addMDDFileAction(fn);
		sp = split(fn);
		store("defDir",defDir = string(sp[1],sp[2]));
	}
	requpdate();
}

addMDDFileAction: fn
{
	
	if(mddList[1] == nil)
		mddList[1] = fn;
	else
		mddList[mddList.size()+1] = fn;
	
}

list_count
{
	if(mddList[1] == nil)
		return(0);
	else
		return(mddList.size());
}

list_names: ndx
{
	if(showFullPath == true)
		return(string(ndx," :: ",mddList[ndx]));
	else
	{
		sp = split(mddList[ndx]);
		return(string(ndx," :: ",sp[3]));
	}
}
updateValues: f
{
	f.rewind();
	duration = number(readInt(f,MOTOROLA));
	vertices = number(readInt(f,MOTOROLA));
	
	startTime = number(readFloat(f,MOTOROLA));
	f.offset(8 + (duration * 4) - 4,FROM_START);
	endTime = number(readFloat(f,MOTOROLA));
	
	setvalue(d1,duration);
	setvalue(d2,vertices);
	setvalue(d3,startTime);
	setvalue(d4,endTime);
	
	fps = getvalue(d0);
	setvalue(d5,startTime * fps);
	setvalue(d6,endTime * fps);
	
	f.close();
}
list_event: ndx
{
	n = ndx[1];
	f = File(mddList[n],"r");
	if(f)
		updateValues(f);
	// look for header
	
}
readInt : inFile, pcOrder
{
   var byte[ 4 ];
   
   readBytes( inFile, byte, 4, pcOrder );

   if ( byte[ 1 ] < 128 )      
      return byte[ 1 ] * 16777216
           + byte[ 2 ] * 65536
           + byte[ 3 ] * 256
           + byte[ 4 ];
   else
      return -(( 255 - byte[ 1 ] ) * 16777216
             + ( 255 - byte[ 2 ] ) * 65536
             + ( 255 - byte[ 3 ] ) * 256
             + ( 256 - byte[ 4 ] ));
}
readBytes : inFile, byte, n, pcOrder
{
   if ( pcOrder ) {
      first = n;
      stop  = 0;
      step  = -1;
   }
   else {
      first = 1;
      stop  = n + 1;
      step  = 1;
   }
   
   for ( i = first; i != stop; i += step )
      byte[ i ] = inFile.readByte();
}
readFloat : inFile, pcOrder
{
   var byte[ 4 ];
   
   readBytes( inFile, byte, 4, pcOrder );

   if ( byte[ 1 ] == 0 && byte[ 2 ] == 0 && byte[ 3 ] == 0 && byte[ 4 ] == 0 )
    return 0;

   m = 1.0 + (( byte[ 2 ] % 128 ) * 65536 + byte[ 3 ] * 256 + byte[ 4 ] )
     / 8388608.0;
   e = ( byte[ 1 ] % 128 ) * 2 + integer( byte[ 2 ] / 128 ) - 127;
   x = m * pow( 2.0, e );
   if ( byte[ 1 ] > 127 ) x = -x;

   return x;
}