@warnings 0
@define INTEGER 4
@define DOUBLE 8
@script motion

frameOffset; defFile; motDir; applyLoadLimit; loadLimit; fmdd;
duration; objType; diag; /*preb; */postb; speed; numpoints;
firstFramePos; firstFrameRot; firstFrameScl;
isAnim_focalLength; isAnim_shutterAngle; isAnim_focalDistance; isAnim_fStop;
mySelf; mySelfOA;
cstr_type;
posx;posy;posz;roth;rotp;rotb;
//sclx;scly;sclz;
startFrame; endFrame;
autoIndex;
userIndex;
pointIndex;
userIndexA;
userIndexB;
bytes;
	
create: obj
{
//	diag = Diagnostic();
//	diag.showonwrite = true;
	autoIndex = integer(recall("autoIndex",1));
	userIndex = integer(recall("userIndex",1));
	userIndexA = integer(recall("userIndexA",1));
	userIndexB = integer(recall("userIndexB",2));
	mySelfOA = obj;
	mySelf = obj.name;
	setdesc("Maya2LW2 MDD Motion");
	contentDir = getdir("Content");
	posx = posy = posz = roth = rotp = rotb = sclx = scly = sclz = 1;
	defFile = recall("defFile",(string(contentDir,"\\*.mdd")));
	(d1,d2) = split(defFile);
	defFile = string(d1,d2,"*.mdd");
	if(defFile.contains(contentDir) == false)
		defFile = string(contentDir,"\\*.mdd");

	speed = number(recall("speed",1));
	// preb = integer(recall("preb",1));
	postb = integer(recall("postb",3));
	frameOffset = integer(recall("frameOffset",0));

	if(appliedBySCGN == true)
	{
		defFile = globalrecall("M2L_SCGN_FN",defFile);
		speed = number(globalrecall("M2L_SCGN_SPEED",speed));
		//preb = integer(globalrecall("M2L_SCGN_PREB",preb));
		postb = integer(globalrecall("M2L_SCGN_POSTB",postb));
		
		frameOffset = integer(globalrecall("M2L_SCGN_TGTSTART",frameOffset));
	}

}

filterMotion: oarray, time, type
{
	farray = <0,0,0>;
	s = mySelfOA.getPosition(time);
	if(type == 1) // pos
	{
		if(posx == true)
			farray.x = oarray.x;
		else
			farray.x = s.x;
		if(posy == true)
			farray.y = oarray.y;
		else
			farray.y = s.y;
		if(posz == true)
			farray.z = oarray.z;
		else
			farray.z = s.z;
	}

	if(type == 2) // rot
	{
		if(roth == true)
			farray.x = oarray.x;
		else
			farray.x = s.x;
		if(rotp == true)
			farray.y = oarray.y;
		else
			farray.y = s.y;
		if(rotb == true)
			farray.z = oarray.z;
		else
			farray.z = s.z;
	}
	
	
	return(farray);
	
}
findPointIndex: str
{
	// start at the end and work backwards
	a = "";
	found = false;
	for(i=str.size();i>=1;i--)
	{
		if(str[i].isDigit())
		{
			// continue working backward until you hit something that is not a digit
			found = true;
			a = str[i] + a;
		}
		else
		{
			if(found == true)
				break;
		}
	}
	if(a == "")
		a = "1";
	return(integer(a));
}
process: ma, frame, time
{
	st_pndx;
	if(st_objectName == nil || st_objectName != mySelf)
	{
		st_objectName = mySelf;
		if(autoIndex == true)
			pointIndex = st_pndx = findPointIndex(st_objectName);
		else
			pointIndex = st_pndx = userIndex;
	}
	
	if(autoIndex == false)
		pointIndex = userIndex;
	else
	{
		if(st_pndx != pointIndex)
			pointIndex = st_pndx = findPointIndex(st_objectName);
	}

	if(fmdd)
	{
		myPos = <0,0,0>;
		myRot = <0,0,0>;
		myScl = <1,1,1>;
		if(fmdd.offset() == -1)
			fmdd.reopen("rb");
		myFrame = ((time * Scene().fps) - frameOffset - 1) / speed;
		if(myFrame < startFrame - frameOffset - 1) // pre behavior
		{
			myFrame = startFrame - frameOffset - 1;
		}	
		if(myFrame >= endFrame - frameOffset - 1) // post behavior
		{
			if(postb == 1) // dissolve
			{
				ma.set(POSITION,<0,0,0>);
				return;
			}
			else if(postb == 2) // first frame
			{
				myFrame = integer(startFrame - frameOffset - 1);
			}
			else if(postb == 3) // last frame
			{
				myFrame = integer(endFrame - frameOffset);
			}
			else if(postb == 4) // loop
			{
				while(myFrame >= duration)
					myFrame = myFrame - endFrame;
			}
		}
		lo = floor(myFrame);
		hi = hif = ceil(myFrame); // hif is for referencing data at hiframe, hi is for computing pct
		
		if(hif == duration)
			hif = 0;
		
		if(hi == lo) // if frame number is exactly on a frame e.g. not fractional
		{
			
			myPos = MDD_findDataAtFrame(lo,pointIndex);
			// this is for rotation
			if(userIndexA && userIndexB)
			{
				myPosA = MDD_findDataAtFrame(lo,userIndexA);
				myPosB = MDD_findDataAtFrame(lo,userIndexB);
				// get the cross product
				forward = normalize(cross3d((myPosA - myPos),(myPosB - myPos)));
				right = (myPosA - myPos);
				up = (myPosB - myPos);
				mat[1] = right;
				mat[2] = up;
				mat[3] = forward;
				myRot = vec_HPB(mat);
				
			}
		}
		if(lo != hi)
		{
			
			pct = (myFrame - lo) / (hi - lo);
			
			loPos = MDD_findDataAtFrame(lo,pointIndex);
			hiPos = MDD_findDataAtFrame(hif,pointIndex);
			myPos = ((hiPos - loPos) * pct) + loPos;
			
			
			if(userIndexA && userIndexB)
			{
				loPos = MDD_findDataAtFrame(lo,userIndexA);
				hiPos = MDD_findDataAtFrame(hif,userIndexA);
				myPosA = ((hiPos - loPos) * pct) + loPos;
				
				loPos = MDD_findDataAtFrame(lo,userIndexB);
				hiPos = MDD_findDataAtFrame(hif,userIndexB);
				myPosB = ((hiPos - loPos) * pct) + loPos;
				
				// get the cross product
				forward = normalize(cross3d((myPosA - myPos),(myPosB - myPos)));
				right = (myPosA - myPos);
				up = (myPosB - myPos);
				mat[1] = right;
				mat[2] = up;
				mat[3] = forward;
				myRot = vec_HPB(mat);
				
			}
		}
		if(posx != false || posy != false || posz != false)
			ma.set(POSITION,filterMotion(myPos,time,1));
		if(roth != false || rotp != false || rotb != false)
			ma.set(ROTATION,filterMotion(myRot,time,2));
	}
	else
	{
		if(fileexists(defFile))
		{
			fmdd = File(defFile,"rb");
			if(!fmdd)
			{
				return;
				//error(string("Error reading ",defFile));
			}
			//findFirstFrames();
			readMDD();
		}
	}
	
}

MDD_findDataAtFrame: myFrame, pntNdx
{
	myFrame = integer(myFrame);
	pntNdx = pntNdx - 1;
	if(pntNdx < 0)
		pntNdx = 0;
	if(fmdd.offset() == -1)
		fmdd.reopen("rb");
	finalOffset = (INTEGER * 2) + (duration * 4) + (numpoints * 4 * 3); // duration and numpoints and time indices and rest pose
	
	mysize = 4*3*numpoints;
	finalOffset = finalOffset + (mysize * myFrame) + (pntNdx * 3 * 4);
	
	if(finalOffset > fmdd.linecount())
		return(<0,0,0>);
	fmdd.offset(finalOffset,FROMSTART);
	
	a = readFloat(fmdd,false);
	b = readFloat(fmdd,false);
	c = readFloat(fmdd,false);
		
	//diag.post(myFrame,"  ",type,<a,b,c>," ",duration," ",f.name());

	return(<a,b,c>);

}

destroy
{
	if(fmdd)
		fmdd.close();
}
refreshUI: val
{
	fn = val;
	if(fileexists(fn))
	{
		openMDDFile(fn);
	}
}
active_reverse: val
{
	if(val == true)
		return(false);
	else
		return(true);
}

options
{
	reqbegin("Maya2LW2 MDD Motion Options");
	cfn_fn = ctlfilename("MDD File",defFile,100,1);
	cint_frameOffset = ctlinteger("Frame Offset",frameOffset);
	ccbx_ndx = ctlcheckbox("Use Item's Name as Point Index [Base-1]",autoIndex);
	cint_ndx = ctlinteger("User Index [Base-1]",userIndex);
	cint_ndxA = ctlinteger("Rotation Pt A [Right]",userIndexA);
	cint_ndxB = ctlinteger("Rotation Pt B [Top]",userIndexB);
	
	cpct_speed = ctlpercent("Speed",speed);
	//cpu_preb = ctlpopup("Pre-behavior",preb,@"Dissolve Out","First Frame"@);
	cpu_postb = ctlpopup("Post-behavior",postb,@"Dissolve Out","First Frame","Last Frame","Loop"@);
	ccbx_px = ctlcheckbox("Position.X",posx);
	ccbx_py = ctlcheckbox("Position.Y",posy);
	ccbx_pz = ctlcheckbox("Position.Z",posz);
	
	ccbx_rx = ctlcheckbox("Rotation.H",roth);
	ccbx_ry = ctlcheckbox("Rotation.P",rotp);
	ccbx_rz = ctlcheckbox("Rotation.B",rotb);
	/*
	ccbx_sx = ctlcheckbox("Scale.X",sclx);
	ccbx_sy = ctlcheckbox("Scale.Y",scly);
	ccbx_sz = ctlcheckbox("Scale.Z",sclz);
	*/
	ctlrefresh(cfn_fn,"refreshUI");
	ctlactive(ccbx_ndx,"active_reverse",cint_ndx);
	return if(!reqpost());

	fn = getvalue(cfn_fn);
		
	frameOffset = getvalue(cint_frameOffset);
	speed = getvalue(cpct_speed);
	//preb = getvalue(cpu_preb);
	store("postb",postb = getvalue(cpu_postb));
	
	posx = getvalue(ccbx_px);
	posy = getvalue(ccbx_py);
	posz = getvalue(ccbx_pz);
	roth = getvalue(ccbx_rx);
	rotp = getvalue(ccbx_ry);
	rotb = getvalue(ccbx_rz);
/*
	sclx = getvalue(ccbx_sx);
	scly = getvalue(ccbx_sy);
	sclz = getvalue(ccbx_sz);
	*/
	autoIndex = getvalue(ccbx_ndx);
	userIndex = getvalue(cint_ndx);
	userIndexA = getvalue(cint_ndxA);
	userIndexB = getvalue(cint_ndxB);
	store("autoIndex",autoIndex);
	store("userIndex",userIndex);
	store("userIndexA",userIndexA);
	store("userIndexB",userIndexB);
	mySelf = mySelfOA.name;
	               
	openMDDFile(fn);
	
}
openMDDFile: fn
{
	if(!fileexists(fn))
		warn("File does not exist.");
	else
	{
		defFile = fn;
		(d1,d2) = split(fn);
		store("defFile",string(d1,d2));
		if(fmdd)
			fmdd.close();
		fmdd = File(fn,"rb");
		if(!fmdd)
			error("Error opening MDD file for reading.");
		else
			readMDD();
		
		// store first frame values

		
	}
	reqend();
}

findFirstFrames
{
	firstFramePos = MDD_findDataAtFrame(0,userIndex);
}
readMDD
{
	
	sp = split(defFile);
	str = string("MDD ",sp[3],sp[4]);
	setdesc(str);
	fmdd.offset(0);
	duration = readInt(fmdd,false);
	numpoints = readInt(fmdd,false);
	startFrame = readFloat(fmdd,false) * Scene().fps;
	fmdd.offset(((duration - 2) * 4),FROMHERE);
	endFrame = readFloat(fmdd,false) * Scene().fps;
	findFirstFrames();
	
}

load: what, io
{
	if(what == SCENEMODE)
	{
		defFile = io.read();
		frameOffset = integer(io.read());
		speed = number(io.read());
//		preb = integer(io.read());
		postb = integer(io.read());
		autoIndex = integer(io.read());
		userIndex = integer(io.read());
		userIndexA = integer(io.read());
		userIndexB = integer(io.read());
		str = io.read();
		posx = integer(str[1]);
		posy = integer(str[2]);
		posz = integer(str[3]);
		roth = integer(str[4]);
		rotp = integer(str[5]);
		rotb = integer(str[6]);
		/*
		sclx = integer(str[7]);
		scly = integer(str[8]);
		sclz = integer(str[9]);
		*/
		
	}
}

save: what, io
{
	if(what == SCENEMODE)
	{
		io.writeln(defFile);
		io.writeln(frameOffset);
		io.writeln(speed);
		// io.writeln(preb);
		io.writeln(postb);
		io.writeln(autoIndex);
		io.writeln(userIndex);
		io.writeln(userIndexA);
		io.writeln(userIndexB);
		//str = string(posx,posy,posz,roth,rotp,rotb,sclx,scly,sclz);
		str = string(posx,posy,posz,roth,rotp,rotb);
		io.writeln(str);
	}
}

findMDDTopHeader: fnf // start and end frames and finds duration
{
	fnf.rewind();
	t = fnf.readInt();
	d = fnf.readInt();
	if(t == 1)
		fnf.offset((DOUBLE * 5) + (INTEGER * 6));
	
	srcStart = fnf.readDouble() * Scene().fps;
	if(t == 1)
		fnf.offset((DOUBLE * 5) + (INTEGER * 6) + (DOUBLE * (d - 1)));
	else if(t == 0)
		fnf.offset(DOUBLE * d);
	srcEnd = fnf.readDouble() * Scene().fps;
	return(t,d,srcStart,srcEnd);
}


writeInt : outFile, i, pcOrder
{
   var byte[ 4 ];

   if ( i >= 0 ) {
      byte[ 1 ] = integer( i / 16777216 );
      byte[ 2 ] = integer( i / 65536 ) % 256;
      byte[ 3 ] = integer( i / 256 ) % 256;
      byte[ 4 ] = i % 256;
   }
   else {
      j = -i - 1;
      byte[ 1 ] = 255 - integer( j / 16777216 );
      byte[ 2 ] = 255 - ( integer( j / 65536 ) % 256 );
      byte[ 3 ] = 255 - ( integer( j / 256 ) % 256 );
      byte[ 4 ] = 255 - ( j % 256 );
   }

   writeBytes( outFile, byte, 4, pcOrder );
}
writeBytes : outFile, byte, n, pcOrder
{
   if ( pcOrder ) {
      first = n;
      stop  = 0;
      step  = -1;
   }
   else {
      first = 1;
      stop  = n + 1;
      step  = 1;
   }

   for ( i = first; i != stop; i += step )
      outFile.writeByte( byte[ i ] );
}

writeFloat : outFile, x, pcOrder
{
   var byte[ 4 ];

   if(x==0)
   {
      byte[ 4 ]=byte[ 3 ]=byte[ 2 ]=byte[ 1 ]=0;
   }
   else
   {
	   lgx = log( abs( x )) / log( 2.0 );
	   e = integer( floor( lgx ));
	   m = integer( floor(( pow( 2.0, lgx - e ) - 1.0 ) * 8388608 ));
	   e += 127;

	   byte[ 1 ] = integer( e / 2 ) + ( x < 0 ? 128 : 0 );
	   byte[ 2 ] = integer( m / 65536 ) + 128 * ( e % 2 );
	   byte[ 3 ] = integer( m / 256 ) % 256;
	   byte[ 4 ] = m % 256;
   }

   writeBytes( outFile, byte, 4, pcOrder );

}
readInt : inFile, pcOrder
{
   var byte[ 4 ];

   readBytes( inFile, byte, 4, pcOrder );

   if ( byte[ 1 ] < 128 )
      return byte[ 1 ] * 16777216
           + byte[ 2 ] * 65536
           + byte[ 3 ] * 256
           + byte[ 4 ];
   else
      return -(( 255 - byte[ 1 ] ) * 16777216
             + ( 255 - byte[ 2 ] ) * 65536
             + ( 255 - byte[ 3 ] ) * 256
             + ( 256 - byte[ 4 ] ));
}

readBytes : inFile, byte, n, pcOrder
{
   if ( pcOrder ) {
      first = n;
      stop  = 0;
      step  = -1;
   }
   else {
      first = 1;
      stop  = n + 1;
      step  = 1;
   }

   for ( i = first; i != stop; i += step )
      byte[ i ] = inFile.readByte();
}
readFloat : inFile, pcOrder
{
   var byte[ 4 ];

   readBytes( inFile, byte, 4, pcOrder );

	   m = 1.0 + (( byte[ 2 ] % 128 ) * 65536 + byte[ 3 ] * 256 + byte[ 4 ] )
	     / 8388608.0;
	   e = ( byte[ 1 ] % 128 ) * 2 + integer( byte[ 2 ] / 128 ) - 127;
	   x = m * pow( 2.0, e );
	   if ( byte[ 1 ] > 127 ) x = -x;

   return x;
}

vec_HPB: mat
{
	//normalises vector then uses trig to solve H,P,B
	l = normalize(mat[1]);
	m = normalize(mat[2]);
	n = normalize(mat[3]);
	rotP = asin(-n.y);

	x = n.z/cos(rotP);
	x = max(-1.0,x);
	x = min(1.0,x);
	rotH = acos(x);
	rotH = (2*PI - rotH) if (n.x<0.0);

	x = m.y/cos(rotP);
	x = max(-1.0,x);
	x = min(1.0,x);
	rotB = acos(x);
	rotB = (2*PI - rotB) if (l.y<0.0);
	rot = <deg(rotH),deg(rotP),deg(rotB)>;
	rot.x = rot.x - 360 if rot.x > 180;
	return(rot);
}