@warnings 0
defUnits;
metricUnits = @"millimeter","centimeter","meter","kilometer","inch","foot","yard","mile"@;
global_mayaHeader;
global_allItemsArray;
list_count
{
	return(global_allItemsArray.size());
}
list_value: ndx
{
	return(global_allItemsArray[ndx].name);
}
initArrays
{
	i = 0;
	m = Mesh();
	while(m)
	{
		global_allItemsArray[++i] = m;
		m = m.next();
	}
	m = Light();
	while(m)
	{
		global_allItemsArray[++i] = m;
		m = m.next();
	}
	m = Camera();
	while(m)
	{
		global_allItemsArray[++i] = m;
		m = m.next();
	}
}
generic
{
	selection = integer(recall("selection",1));
	initArrays();
	
	
	fn = getfile("Save Maya ASCII scene","*.ma",true);
	if(!fn)
		error("User aborted.");
	fout = File(fn,"w");
	if(!fout)
		error("Unable to open file for writing.");
	
	reqbegin("Export to Maya ASCII");
	c1 = ctlchoice("Selection",selection,@"Use Layout-selected","Select from list"@);
	c2 = ctllistbox("Items",300,300,"list_count","list_value");
	return if(!reqpost());
		
	selection = getvalue(c1);
	selected = getvalue(c2);
	store("selection",selection);
	reqend();
	
	writeHeader(fout);
	dataArray = nil;
	if(selection == 1)
	{
		s = Scene().getSelect();
		if(!s)
			error("Select an item.");
	}
	if(selection == 2)
	{
		j=0;
		for(i=1;i<=selected.size();i++)
		{
			sndx = selected[i];
			s[i] = global_allItemsArray[sndx];
		}
	}
	for(i=1;i<=s.size();i++)
	{
		if(s[i].genus == CAMERA)
			createElement(fout,s[i].name,"camera",s[i], dataArray);
		if(s[i].genus == MESH)
		{
			if(s[i].null)
				createElement(fout,s[i].name,"locator",s[i], dataArray);
			else
				createElement(fout,s[i].name,"transform",s[i], dataArray);
		}
		if(s[i].genus == LIGHT)
			createElement(fout,s[i].name,"light",s[i], dataArray);
	}

		
}

writeHeader: fout
{
	i = 0;
	//Maya ASCII 8.0 scene
	//Name: 0-0-0_EMPIRE_TRANSITION_A.CAM_RENDER.ma
	//Last modified: Thu, Jun 26, 2008 01:09:19 PM
	//requires maya "8.0";
	global_mayaHeader[++i] = "//Maya ASCII 8.0 scene";
	global_mayaHeader[++i] = "//Maya ASCII File generated by Maya2LW[2]";
	global_mayaHeader[++i] = "requires maya \"8.0\"\;";
	global_mayaHeader[++i] = "currentUnit -l centimeter -a degree -t ntsc\;";
	global_mayaHeader[++i] = "fileInfo \"application\" \"maya\"\;";
	global_mayaHeader[++i] = "fileInfo \"product\" \"Maya Complete 8.0\"\;";
	global_mayaHeader[++i] = "fileInfo \"version\" \"8.0\";";
	global_mayaHeader[++i] = "fileInfo \"cutIdentifier\" \"200607192324-680053\"\;";
	global_mayaHeader[++i] = "fileInfo \"osv\" \"Microsoft Windows XP Service Pack 2 (Build 2600)\\n\"\;";
	
	for(i=1;i<=global_mayaHeader.size();i++)
	{
		str = global_mayaHeader[i];
		fout.writeln(str);
	}
	
}
connectNodes: src, tgt, attrib
{
	src = quote(string(src,".o"));
	fintgt = quote(tgt + "." + attrib);
	str = string("connectAttr ",src," ",fintgt,"\;");
	return(str);
}
//writes the needed stuff 
createElement: fout, name, type, obj, dataArray
{
	
	if(fout == nil)
		return(nil);
	
	str = string("createNode transform -n ",quote(name),"\;");
	fout.writeln(str);
	str = string("setAttr \".ro\" 2\;");
	fout.writeln(str);
	if(type == "light")
	{
		if(obj.type == DISTANTLIGHT)
			lightType = "directionalLight";
		if(obj.type == POINTLIGHT)
			lightType = "pointLight";
		if(obj.type == SPOTLIGHT)
			lightType = "spotLight";
		if(obj.type == AREALIGHT)
			lightType = "areaLight";
		if(obj.type == LINEARLIGHT)
			lightType = "areaLight";
		
		shapeNode = name + "Shape";
		str = string("createNode ",lightType," -n ",quote(shapeNode)," -p ",quote(name),"\;");
		fout.writeln(str);
	}
	if(type == "locator")
	{
		shapeNode = name + "Shape";
		str = string("createNode locator -n ",quote(shapeNode)," -p ",quote(name),"\;");
		fout.writeln(str);
	}
	if(type == "camera")
	{
		apertureHeight = 2 * obj.focalLength(0) / obj.zoomFactor(0) * .03937;
		shapeNode = name + "Shape";
		str = string("createNode camera -n ",quote(shapeNode)," -p ",quote(name),"\;");
		fout.writeln(str);
		str = string("setAttr -k off ",quote(".v"),"\;");
		fout.writeln(str);
		str = string("setAttr ",quote(".cap")," -type ",quote("double2")+" ",1.26," ",apertureHeight,"\;");
		fout.writeln(str);
		str = string("setAttr ",quote(".ff")," 2","\;");
		fout.writeln(str);
		str = string("setAttr ",quote(".ncp")," 0.01","\;");
		fout.writeln(str);
		str = string("setAttr ",quote(".fd")," 1","\;");
		fout.writeln(str);
		str = string("setAttr ",quote(".ow")," 30","\;");
		fout.writeln(str);

		nodeName = writeAnimation(fout,obj,"focalLength");
		fout.writeln(connectNodes(nodeName,shapeNode,"focalLength"));
		
	}
		
	nodeName = writeAnimation(fout,obj,"translateX");
	fout.writeln(connectNodes(nodeName,name,"tx"));
	nodeName = writeAnimation(fout,obj,"translateY");
	fout.writeln(connectNodes(nodeName,name,"ty"));
	nodeName = writeAnimation(fout,obj,"translateZ");
	fout.writeln(connectNodes(nodeName,name,"tz"));
	nodeName = writeAnimation(fout,obj,"rotateX");
	fout.writeln(connectNodes(nodeName,name,"rx"));
	nodeName = writeAnimation(fout,obj,"rotateY");
	fout.writeln(connectNodes(nodeName,name,"ry"));
	nodeName = writeAnimation(fout,obj,"rotateZ");
	fout.writeln(connectNodes(nodeName,name,"rz"));
	nodeName = writeAnimation(fout,obj,"scaleX");
	fout.writeln(connectNodes(nodeName,name,"sx"));
	nodeName = writeAnimation(fout,obj,"scaleY");
	fout.writeln(connectNodes(nodeName,name,"sy"));
	nodeName = writeAnimation(fout,obj,"scaleZ");
	fout.writeln(connectNodes(nodeName,name,"sz"));
	
}
//type eg translateX
writeAnimation: fout, obj, type
{
	startFrame = Scene().previewstart;
	endFrame = Scene().previewend;
		
	duration = endFrame - startFrame + 1;
	if(type.contains("translate"))
		node = "animCurveTL";
	if(type.contains("rotate"))
		node = "animCurveTA";
	if(type.contains("scale") || type.contains("focalLength"))
		node = "animCurveTU";
	
	nodeName = obj.name+"_"+type;
	
	str = string("createNode ",node," -n ",quote(nodeName),"\;");
	fout.writeln(str);
	
	str = string("setAttr ",quote(".tan")," 10","\;");
	fout.writeln(str);
	str = string("setAttr ",quote(".wgt")," no","\;");
	fout.writeln(str);
	str = string("setAttr -s ",duration," ",quote(".ktv"),"\;");
	fout.writeln(str);
	
	tempstr = string(".ktv",rangeArray(string(0),string(duration - 1)));
	str = string("setAttr ",quote(tempstr));
	fout.writeln(str);
	
	for(j=startFrame,i=0;i<=duration - 1;i++,j++)
	{
		if(type.contains("translate"))
		{
			data = obj.getPosition(j / Scene().fps);
			data.z = -data.z;
		}
		if(type.contains("rotate"))
		{
			data = <0,0,0>;
			tempdata = obj.getRotation(j / Scene().fps);
			data.x = -tempdata.y;
			data.y = -tempdata.x;
			data.z = -tempdata.z;
		}
		if(type.contains("scale"))
			data = obj.getScaling(j / Scene().fps);
		if(type.contains("focalLength"))
			dataNum = obj.focalLength(j / Scene().fps);
		
		if(type.contains("X"))
			str = string(j," ",data.x);
		if(type.contains("Y"))
			str = string(j," ",data.y);
		if(type.contains("Z"))
			str = string(j," ",data.z);
		if(type.contains("focalLength"))
			str = string(j," ",dataNum);
		fout.writeln(str);
	}
	fout.writeln("\;");
	tempstr = string(".kot",rangeArray(string(0),string(duration - 1)));
	str = string("setAttr -s ",duration," ",quote(tempstr));
	fout.writeln(str);
	for(j=startFrame,i=0;i<=duration - 1;i++,j++)
	{
		fout.writeln("9");
	}
	fout.writeln("\;");
	
	return(nodeName);

}
rangeArray: min, max
{
	finstr = string("[",min,":",max,"]");
	return(finstr);
}
quote: str
{
	if(str)
	{
		return("\"" + str + "\"");
	}
	else
		return(str);
}

checkDuplicateNames: thisName
{
	if(myNameList.contains(thisName))
	{
		
		i = 1;
		while(myNameList.contains(string(thisName,i)))
			i++;
		thisName = string(thisName,i);
		return(thisName);
	}
	else
		return(thisName);
}
writeTail: f, snodes
{
	f.writeln(string("createNode lightLinker -n \"lightLinker1\"\;"));
	f.writeln(string("createNode materialInfo -n \"materialInfo1\"\;"));
	f.writeln(string("createNode shadingEngine -n \"Default1SG\"\;"));
	f.writeln(string("createNode lambert -n \"Default1\"\;"));
	f.writeln(string("setAttr \".c\" -type \"float3\" 0.75 0.75 0.75\;"));
	f.writeln(string("setAttr \".dc\" 1 \;"));
	//f.writeln(string("setAttr \".sc\" 0 0 0 \;"));
	//f.writeln(string("setAttr \".cp\" 32 \;"));
	f.writeln(string("connectAttr \"lightLinker1.msg\" \":lightList1.ln\" -na\;"));
	f.writeln(string("connectAttr \":defaultLightSet.msg\" \"lightLinker1.lnk[0].llnk\"\;"));
	f.writeln(string("connectAttr \"Default1SG.msg\" \"materialInfo1.sg\"\;"));
	f.writeln(string("connectAttr \"Default1.oc\" \"Default1SG.ss\"\;"));
	f.writeln(string("connectAttr \"Default1SG.pa\" \":renderPartition.st\" -na\;"));
	f.writeln(string("connectAttr \"Default1.msg\" \":defaultShaderList1.s\" -na\;"));
	for(i=1;i<=snodes.size();i++)
		f.writeln(string("connectAttr \"",snodes[i],".iog\" \"Default1SG.dsm\" -na\;"));
	
}
writeShapeNode: f, myName, pc
{
	string("createNode mesh -n \"",myName,"Shape","\""," -p \"",myName,"\";"); f.writeln(this);
	string("\t","setAttr -k off \".v\"\;"); f.writeln(this);
	string("\t","setAttr \".vir\" yes\;"); f.writeln(this);
	string("\t","setAttr \".vif\" yes\;"); f.writeln(this);
	string("\t","setAttr -s ",pc," \".vt\"\;"); f.writeln(this);
	
	
}
writeTransformNode: f, myName
{
	string("createNode transform -n \"",myName,"\"\;"); f.writeln(this);
}
writeHeader: f, curUnit
{
	string("//Maya ASCII Scene"); f.writeln(this);
	string("//Maya ASCII File generated by Maya2LW[2]"); f.writeln(this);
	string("//Maya2LW[2] Open Source Project by Lernie Ang (faulknermano@yahoo.com)"); f.writeln(this);
	string("//LW-side Exporter tested on Maya 6.5 Platform"); f.writeln(this);
	string("requires maya \"5.0\"\;"); f.writeln(this);
	string("currentUnit -l ",curUnit," -a degree\;"); f.writeln(this);
	
	
	
}

goToMorphMap: oa
{
	pc = editbegin() || error("No points.");
	pnt = points[1];
	
	if(oa.isMapped(pnt))
	{
		myVal = oa.getValue(pnt);
		oa.setValue(pnt,myVal);
	}
	else
	{
		oa.setValue(pnt,nil);
	}
	editend();
}